Package: WrightMap
Type: Package
Title: IRT Item-Person Map with 'ConQuest' Integration
Version: 1.5
Date: 2026-08-23
Authors@R: c(person(given = "David",
                    family = "Torres Irribarra",
                    role = c("aut", "cre"),
                    email = "david@torresirribarra.me"),
             person(given = "Rebecca",
                    family = "Freund",
                    role = "aut"),
             person(given = "Joshua A.",
                    family = "McGrane",
                    role = "ctb"))
Maintainer: David Torres Irribarra <david@torresirribarra.me>
Description: A powerful yet simple graphical tool available in the field of psychometrics is the Wright Map (also known as item maps or item-person maps), which presents the location of both respondents and items on the same scale. Wright Maps are commonly used to present the results of dichotomous or polytomous item response models. The 'WrightMap' package provides functions to create these plots from item parameters and person estimates stored as R objects. Although the package can be used in conjunction with any software used to estimate the IRT model (e.g. 'TAM', 'mirt', 'eRm' or 'IRToys' in 'R', or 'Stata', 'Mplus', etc.), 'WrightMap' features special integration with 'ConQuest' to facilitate reading and plotting its output directly. The 'wrightMap' function creates Wright Maps based on person estimates and item parameters produced by an item response analysis. The 'CQmodel' function reads output files created using 'ConQuest' software and creates a set of data frames for easy data manipulation, bundled in a 'CQmodel' object. The 'wrightMap' function can take a 'CQmodel' object as input or it can be used to create Wright Maps directly from data frames of person and item parameters.
License: BSD_2_clause + file LICENSE
Depends: R (>= 3.0.0)
Imports: methods, RColorBrewer
Encoding: UTF-8
Config/roxygen2/version: 8.1.0
NeedsCompilation: no
Packaged: 2026-08-23 12:02:04 UTC; dti
Author: David Torres Irribarra [aut, cre],
  Rebecca Freund [aut],
  Joshua A. McGrane [ctb]
Repository: CRAN
Date/Publication: 2026-08-23 15:10:12 UTC
Built: R 4.6.0; ; 2026-08-23 16:19:26 UTC; unix

Package: WrightMap
Type: Package
Title: IRT Item-Person Map with 'ConQuest' Integration
Version: 1.4
Date: 2024-09-24
Authors@R: c(person(given = c("David"),
                      family = "Torres Irribarra",
                      role = c("aut", "cre"),
                      email = "david@torresirribarra.me"),
                      person(given = "Rebecca",
                      family = "Freund",
                      role = "aut"))
Maintainer: David Torres Irribarra <david@torresirribarra.me>
Description: A powerful yet simple graphical tool available in the field of psychometrics is the Wright Map (also known as item maps or item-person maps), which presents the location of both respondents and items on the same scale. Wright Maps are commonly used to present the results of dichotomous or polytomous item response models. The 'WrightMap' package provides functions to create these plots from item parameters and person estimates stored as R objects. Although the package can be used in conjunction with any software used to estimate the IRT model (e.g. 'TAM', 'mirt', 'eRm' or 'IRToys' in 'R', or 'Stata', 'Mplus', etc.),  'WrightMap' features special integration with 'ConQuest' to facilitate reading and plotting its output directly.The 'wrightMap' function creates Wright Maps based on person estimates and item parameters produced by an item response analysis. The 'CQmodel' function reads output files created using 'ConQuest' software and creates a set of data frames for easy data manipulation, bundled in a 'CQmodel' object. The 'wrightMap' function can take a 'CQmodel' object as input or it can be used to create Wright Maps directly from data frames of person and item parameters.
License: BSD_2_clause + file LICENSE
Depends: R (>= 3.0.0)
Imports: methods, RColorBrewer
Encoding: UTF-8
NeedsCompilation: no
Packaged: 2024-09-24 05:57:15 UTC; dti
Author: David Torres Irribarra [aut, cre],
  Rebecca Freund [aut]
Repository: CRAN
Date/Publication: 2024-09-24 06:20:02 UTC
Built: R 4.6.0; ; 2026-04-26 20:26:27 UTC; unix

exportPattern("^[[:alpha:]]+")

importFrom("grDevices", "dev.new", "rgb")
importFrom("graphics", "abline", "axis", "box", "hist", "layout",
     "lines", "mtext", "par", "plot", "points", "polygon",
     "rect", "text", "title")
importFrom("graphics", "close.screen", "screen", "segments",
             "split.screen", "legend")
importFrom("stats", "density", "na.omit", "optimize", "quantile",
     "reshape", "aggregate", "qnorm", "rnorm", "runif")
importFrom("utils", "read.delim", "read.fwf", "read.table", "modifyList")
importFrom("methods", "is")
importFrom("RColorBrewer", "brewer.pal")

S3method(difplot,CQmodel )
S3method(difplot,character )
S3method(difplot,default )
S3method(fitgraph,CQmodel)
S3method(fitgraph,character )
S3method(fitgraph,default )
S3method(fitgraph,numeric )
S3method(itemData,CQmodel)
S3method(itemData,character )
S3method(itemData,default )
S3method(make.deltas,CQmodel)
S3method(make.deltas,character )
S3method(make.deltas,default )
S3method(make.thresholds,CQmodel)
S3method(make.thresholds,character )
S3method(make.thresholds,default)
S3method(make.thresholds,matrix )
S3method(personData,CQmodel )
S3method(personData,character)
S3method(personData,default )
S3method(plot,CQmodel )
S3method(print,CQmodel )
S3method(print,SOE)

Wright Map
=========

IRT Item-Person Map with 'ConQuest' Integration

Package: WrightMap

Type: Package

Version: 1.4

Date: 2024-09-24

Author: David Torres Irribarra & Rebecca Freund

Maintainer: david@torresirribarra.me, rlfreund@berkeley.edu

Description: The wrightMap function creates Wright Maps based on person estimates and item parameters produced by an item response analysis. The CQmodel function reads output files created using ConQuest software and creates a set of data frames for easy data manipulation, bundled in a CQmodel object. The wrightMap function can take a CQmodel object as input or it can be used to create Wright Maps directly from data frames of person and item parameters.

License: BSD 2 clause

Acknowledgments: Our thanks to Ronli Diakow & Beth Ayers for all their feedback and help.

plotCI <-
function(ests, errors, labels = "", zeroline = TRUE, incol = "gray", outcol = "blue", 
	main.title = "Statistical Significance Plot", axes = FALSE, xlab = "", pch = 16, ...) {

	xcorrs = 1:length(ests)
	errors[is.na(errors)] <- 0
	print(errors)
	lowerbounds = ests - 1.96 * errors
	upperbounds = ests + 1.96 * errors
	blackorblue <- function(lower, upper, incol, outcol) {
		if (lower < 0 && 0 < upper) {
			incol
		} else outcol
	}
	col = mapply(blackorblue, lowerbounds, upperbounds, incol, outcol)
	plot(xcorrs, ests, axes = axes, xlab = xlab, col = col, pch = pch, ...)
	axis(2, las = 1)
	box()
	segments(x0 = xcorrs, y0 = lowerbounds, y1 = upperbounds, col = col, lwd = 2, lend = 1)
	
	text(xcorrs, upperbounds, labels, cex = 0.7, col = col, pos = 3, offset = .1)
	
	if (zeroline) 
		abline(h = 0, lty = "dashed")

	title(main.title)

}

personData.CQmodel <- function(thetas, ...) {
	
	model <- thetas
	
	if(!is.null(model$p.est)) {
	p.est <- model$p.est
	columns.at <- grep("^est", names(p.est), perl = TRUE)
	thetas <- p.est[columns.at]
	}
	else
		thetas <- 0
		
	names(thetas) <- model$dimensions
	return(thetas)
	
}

print.SOE <-
function(x, ...) {
	scipen <- getOption("scipen")
	options(scipen = 999)
	cat("\nSummary of estimation\n\n")
	cat("Estimation method:", x$method, "\n")
	cat("Assumed population distribution:", x$distribution, "\n")
	cat("Constraint:", x$constraint, "\n\n")

	cat("Termination criteria:\n     ", x$max.iterations, "iterations\n     ", x$parameter.change, "change in parameters\n     ", 
		x$deviance.change, "change in deviance\n     ", x$max.iterations.no.improvement, "iterations without a deviance improvement\n     ", 
		x$max.steps, "Newton steps in M-step\n")

	m <- regexec("Iterations terminated because ", x$termination.reason)
	reason <- paste(unlist(regmatches(x$termination.reason, m, invert = TRUE)), collapse = "")
	cat("Estimation terminated after ", x$iterations, " iterations because ", reason, ".\n\n", sep = "")

	cat("Random number generation seed:", x$seed, "\n")
	cat(x$PV.nodes, "nodes used for drawing", x$n.plausible.values, "plausible values", "\n")
	cat(x$fit.nodes, "nodes used when computing fit", "\n")
	cat("Value for obtaining finite MLEs for zero/perfects:", x$zero.perfect.value, "\n")
	cat("\n")
	options(scipen = scipen)

}

personHist <-
function(thetas, yRange = NULL, breaks = "FD", dim.lab.cex = 0.6, dim.lab.side = 3, dim.lab.adj = 0.5, dim.names = NULL, dim.color = "white", person.points = NULL, person.range = NULL, p.point.col = "gray45", p.range.col = "gray75",axis.persons = "Respondents", show.axis.persons = FALSE, axis.persons.par = list(), oma = c(0, 5, 0, 5), axis.logits = "Logits", show.axis.logits = TRUE,...) {

	densExt <- function(densElem) {
		bin.size <- abs(densElem$breaks[1] - densElem$breaks[2])
		thetaHist <- data.frame(xleft = densElem$mids - (bin.size/2), ybottom = densElem$mids * 0, xright = densElem$mids + (bin.size/2), 
			ytop = densElem$counts)

		return(thetaHist)
	}

	theta.dens <- function(thetas, breaks) {
		densList <- apply(thetas, 2, hist, plot = FALSE, breaks = breaks)
		distInfo <- lapply(densList, densExt)
		return(distInfo)
	}

	person.plot <- function(distInfo, yRange, p.points, p.range, p.col, r.col, dim.lab.side, dim.lab.cex, dim.lab.adj, p.cex.lab, p.font.lab, p.lwd) {

		
		par(mar = c(op$mar[1], 0.2, op$mar[3], 0.1))

		plot(c(min(distInfo[, 1]), max(distInfo[, 3])), c(min(distInfo[, 2]), max(distInfo[, 4])), ylim = yRange, xlim = c(max(distInfo[, 
			4]), 0), type = "n", ylab = "", xlab = "", axes = FALSE, cex.lab = p.cex.lab, font.lab = p.font.lab, lwd = p.lwd)
			
			if(screen() == first)
				mtext(axis.persons, side = 2, line = 1, cex = 0.8, font = 3)
			
			draw.range <- function(upper, lower, col, distInfo) {
				in.range <- distInfo[,1] < upper & distInfo[,3] > lower
				range.info <- distInfo[in.range,]
				rect(range.info[, 4], range.info[, 1], range.info[, 2], range.info[, 3], col = col)
			}
			
			draw.point <- function(pt, col, distInfo) {
				has.point <- distInfo[,1] - pt <= 0 & distInfo[,3] - pt > 0
				point.info <- distInfo[has.point,]
				rect(point.info[, 4], point.info[, 1], point.info[, 2], point.info[, 3], col = col)
			}
			
			rect(distInfo[, 4], distInfo[, 1], distInfo[, 2], distInfo[, 3], col = attr(distInfo, "dim.color"))
		
			
			
			if(!is.null(p.range)) {
				p.range <- matrix(p.range,nrow = 2)
				lower <- p.range[1,]
				upper <- p.range[2,]
				mapply(draw.range,upper,lower,r.col,list(distInfo))
			}
			if(!is.null(p.points)) {
				mapply(draw.point,p.points,p.col,list(distInfo))
			}
			
			axis.pers <- function(side = 1, ...) {
				axis(side = side, ...)
			}
			if(show.axis.persons) { 
				do.call(axis.pers,axis.persons.par)
			}
			

		
		
		mtext(attr(distInfo, "dim.name"), side = dim.lab.side, line = -1, cex = dim.lab.cex, font = 1, adj = dim.lab.adj)
		box(bty = "c")

		if (screen() != max(split.screen())) 
			screen(screen() + 1)
	}

	thetas <- as.matrix(thetas)
	nD <- ncol(thetas)

	if (is.null(yRange)) 
		yRange <- c(min(thetas), max(thetas))

	distInfo <- theta.dens(thetas, breaks)

	if (is.null(dim.names)) {
		if (!is.null(names(thetas))) {
			dim.names <- names(thetas)
		} else if (nD == 1) {
			dim.names <- ""
		} else {
			dim.names <- c(paste("Dim", seq(1:nD), sep = ""))
		}
	}

	if (ncol(thetas) > 1 & length(dim.color) == 1) {
		dim.color <- rep(dim.color, ncol(thetas))
	}

	for (i in 1:nD) {
		attr(distInfo[[i]], "dim.name") <- dim.names[i]
		attr(distInfo[[i]], "dim.color") <- dim.color[i]
	}
	old.screens <- split.screen()
	split.screen(c(1, nD))

	first <- screen()
	

	op <- par("mar","oma")

	par(oma = oma)

	
	

	lapply(distInfo, FUN = person.plot, yRange = yRange, p.points = person.points, p.range = person.range, p.col = p.point.col, r.col = p.range.col, dim.lab.cex = dim.lab.cex, dim.lab.side = dim.lab.side, dim.lab.adj = dim.lab.adj, 
		p.cex.lab = 1.3, p.font.lab = 3, p.lwd = 2)
	if (show.axis.logits) {
		axis(4, las = 1, cex.axis = 0.7, font.axis = 2)
	}
	mtext(axis.logits, side = 4, line = 1.5, cex = 0.8, font = 3)
	
	curr.screens <- split.screen()
	new.screens <- curr.screens[!(curr.screens %in% old.screens) ]
	close.screen(new.screens)


}

itemClassic <- function(thr, yRange = NULL, axis.items = "Items",
                        axis.logits = "Logits", show.axis.logits = "R",
                        axis.logits.cex = 0.7, oma = c(0, 0, 0, 3),
                        cutpoints = NULL, cutpoints.par = list(), label.items = NULL,
                        label.steps = NULL, label.steps.type = NULL,
                        label.sep = ".", thr.lab.sep = " | ",
                        thr.lab.par = list(), axis.logits.par = list(),
                        logits.text.par = list(), pad.char = "_",
                        font.family = "mono", ...) {
  
  # Helper function to generate breaks for the histogram
  Nbins <- function(thr, itemRange) {
    breaks <- seq(from = itemRange[1], to = itemRange[2], length.out = 25)
    
    if (min(thr, na.rm = TRUE) < min(breaks)) 
      breaks <- c(min(thr, na.rm = TRUE), breaks)
    if (max(thr, na.rm = TRUE) > max(breaks)) 
      breaks <- c(breaks, max(thr, na.rm = TRUE))
    
    return(breaks)
  }

  # Helper function to bin items by level
  binItems <- function(level, labelMat, cutMat) {
    paste(sort(labelMat[cutMat == level]), collapse = thr.lab.sep)
  }
  
  thr <- as.matrix(thr)
  nI <- nrow(thr)
  nL <- ncol(thr)
  
  # Set yRange if not provided
  if (is.null(yRange)) {
    yRange <- range(thr, na.rm = TRUE)
    yA <- (yRange[2] - yRange[1]) * 0.1
    yRange <- yRange + c(-yA, yA)
  }

  # Set up outer margins and adjust axis label positions
  par(oma = oma)
  par(mgp = c(3, 1, 0))

  # Plot the empty canvas for the histogram
  plot(seq(1:nI), rep(0, nI), type = "n", axes = FALSE, xlab = axis.items, 
       ylab = "", ylim = yRange, xlim = c(0.5, nI + 0.5), cex.lab = 0.8, 
       font.lab = 3)
  
  box(bty = "o")

  # Show logit axis based on the provided position and add customization
  if (show.axis.logits != FALSE) {
    axis.l <- function(side = 4, las = 1, cex.axis = axis.logits.cex, font.axis = 2, ...) {
      return(list(side = side, las = las, cex.axis = cex.axis, font.axis = font.axis, ...))
    }
    
    if (show.axis.logits == "L") {
      axis.logits.par$side <- 2
    } else {
      axis.logits.par$side <- 4
    }

    # Ensure cex.axis defaults to axis.logits.cex if not provided
    if (is.null(axis.logits.par$cex.axis)) {
      axis.logits.par$cex.axis <- axis.logits.cex
    }
    
    axis.logits.par <- do.call(axis.l, axis.logits.par)
    do.call(axis, axis.logits.par)
    
    logits.text <- function(text = axis.logits, side = axis.logits.par$side, 
                            line = 1.5, cex = 0.8, font = 3, ...) {
      return(list(text = text, side = side, line = line, cex = cex, font = font, ...))
    }
    
    logits.text.par <- do.call(logits.text, logits.text.par)
    do.call(mtext, logits.text.par)
  }

  # Plot cutpoints if provided and customize with `cutpoints.par`
  if (!is.null(cutpoints)) {
    cutpoints.default <- list(col = "grey90", lwd = 1, lty = 1)
    cutpoints.par <- modifyList(cutpoints.default, cutpoints.par)
    abline(h = cutpoints, col = cutpoints.par$col, lwd = cutpoints.par$lwd, lty = cutpoints.par$lty)
  }
  
  # Create histogram data
  item.hist <- hist(thr, plot = FALSE, breaks = Nbins(thr, yRange))
  itemBinLocations <- item.hist$mids
  bin.size <- abs(item.hist$breaks[1] - item.hist$breaks[2])
  
  item.hist <- data.frame(xleft = item.hist$mids - (bin.size / 2), 
                          ybottom = item.hist$mids * 0,
                          xright = item.hist$mids + (bin.size / 2), 
                          ytop = item.hist$counts)

  # Handle labels for items (padding them with selected character)
  if (is.null(label.items)) {
    label.items <- formatC(1:nI, digits = 1, format = "d", flag = "0")
  }
  
  # Pad all item labels to the same length using the selected character
  maxLabelLength <- max(nchar(label.items))
  label.items <- sapply(label.items, function(label) {
    gsub(" ", pad.char, sprintf(paste0("%-", maxLabelLength, "s"), label))
  })
  
  label.items <- matrix(label.items, ncol = 1)
  
  # Handle step labels for thresholds
  if (is.null(label.steps)) {
    if (!is.null(label.steps.type) && label.steps.type == "transition") {
      # Transition labels: 0/1, 1/2, 2/3, etc.
      label.steps <- paste0((1:nL) - 1, "/", 1:nL)
    } else {
      # Default labels: 1, 2, 3, etc.
      label.steps <- 1:nL
    }
  } else if (is.logical(label.steps) && label.steps) {
    # Use column names if available and all non-empty, otherwise default to numeric
    cnames <- colnames(thr)
    has_meaningful_colnames <- !is.null(cnames) && all(nzchar(cnames))
    label.steps <- if (has_meaningful_colnames) cnames else 1:nL
  }

  # Generate item labels if multiple levels
  if (nL > 1) {
    item.labels <- t(apply(label.items, 1, paste, label.steps, sep = label.sep))
  } else {
    item.labels <- label.items
  }

  # Bin the items
  binnedItems <- matrix(cut(thr, breaks = Nbins(thr, yRange), labels = c(1:length(item.hist[, 1] + 1))), 
                        ncol = nL)
  
  binnedList <- unlist(lapply(1:length(itemBinLocations), binItems, item.labels, binnedItems))

  # Customizable threshold labels with optional font family
  thr.lab <- function(x = 0, pos = 4, offset = 1 * 15 / nI, cex = 0.65, family = font.family, ...) {
    return(list(x = x, y = itemBinLocations, labels = binnedList, pos = pos, 
                offset = offset, cex = cex, family = family, ...))
  }
  
  thr.lab.par <- do.call(thr.lab, thr.lab.par)
  do.call(text, thr.lab.par)
}

make.thresholds.CQmodel <-
function(item.params,item.table = NULL,interactions = NULL,step.table = NULL,design.matrix = "normal",throld = .5,alpha = 1,...) {
	deltas <- make.deltas(item.params,item.table,interactions,step.table)
	#message("Creating threshold parameters out of deltas")
	return(make.thresholds(deltas,throld = throld,alpha = alpha,...))
}

	extract.deltas <- function(tamObject){

		delta.long <- tamObject$xsi

		n.deltas <- apply(tamObject$B,1,max)

		delta.mat <- matrix(NA, nrow = length(n.deltas), ncol = max(n.deltas))

		matCoords.row <- rep(1:length(n.deltas), n.deltas)

		matCoords.col <- c()

		for(i in 1:length(n.deltas)){

			for (j in 1:n.deltas[i]) {

				matCoords.col <- c(matCoords.col, j)

			}

		}

		delta.long$matCoords.row <- matCoords.row
		delta.long$matCoords.col <- matCoords.col

		for (k in 1:nrow(delta.long)) {

			delta.mat[delta.long$matCoords.row[k],delta.long$matCoords.col[k]] <- delta.long$xsi[k]

		}

		delta.mat

	}

print.CQmodel <-
function(x, ...) {

	catnull <- function(x, y, ...) {
		if (!is.null(x)) 
			cat(y, ...)
	}

	cat("\n")
	cat("ConQuest Output Summary:\n")
	cat("========================\n")
	catnull(x$title, x$title, "\n\n")
	catnull(x$equation, "The item model:", x$equation, "\n")
	catnull(x$nDim, x$nDim, ifelse(x$nDim == 1, "dimension", "dimensions"), "\n")
	catnull(x$participants, x$participants, "participants\n")
	catnull(x$deviance, "Deviance: ", x$deviance, " (", x$parameters, " parameters)\n\n", sep = "")
	cat("Additional information available:\n")
	catnull(x$SOE, "Summary of estimation: $SOE\n")
	catnull(x$RMP, "Response model parameter estimates: $RMP\n")
	catnull(x$reg.coef, "Regression coefficients: $reg.coef\n")
	catnull(x$variances, "Variances: $variances\n")
	catnull(x$cor.matrix, "Correlation matrix: $cor.matrix\n")
	catnull(x$cov.matrix, "Covariance matrix: $cov.matrix\n")
	catnull(x$rel.coef, "Reliabilities: $rel.coef\n")
	catnull(x$GIN, "GIN tables (thresholds): $GIN\n")
	catnull(x$GIN.deltas, "GIN tables (deltas): $GIN.deltas\n")
	catnull(x$p.est, paste(x$p.est.type, " table: $p.est\n", sep = ""))
	catnull(x$run.details, "Additional details: $run.details\n")
	cat("\n")
}

itemModern <- function(thr, yRange = NULL, axis.items = "Items",
                       show.thr.sym = TRUE, thr.sym.cex = .8,
                       thr.sym.lwd = 1, thr.sym.pch = 23,
                       thr.sym.col.fg = rgb(0, 0, 0, 0.3),
                       thr.sym.col.bg = rgb(0, 0, 0, 0.3),
                       show.thr.lab = TRUE, thr.lab.pos = c(2, 4),
                       thr.lab.text = NULL, thr.lab.type = NULL,
                       thr.lab.col = "black",
                       thr.lab.cex = .5, thr.lab.font = 2,
                       label.items.rows = 1, label.items.srt = 0, 
                       label.items = NULL, label.items.cex = 0.6, 
                       label.items.ticks = TRUE, axis.logits = "Logits", 
                       show.axis.logits = "R", axis.logits.cex = 0.7, 
                       oma = c(0, 0, 0, 3), cutpoints = NULL, 
                       vertLines = FALSE, vertLines.par = list(), 
                       cutpoints.par = list(),
                       thr.sym.par = list(), thr.lab.par = list(), 
                       label.items.par = list(), axis.logits.par = list(), 
                       logits.text.par = list(), ...) {
    
    # Ensure 'thr' is a matrix
    thr <- as.matrix(thr)
    nI <- nrow(thr)
    
    # Set y-axis range based on threshold values if not provided
    if (is.null(yRange)) {
        yRange <- range(thr, na.rm = TRUE)
    }
    
    # Set default threshold labels if not provided
    if (is.null(thr.lab.text)) {
        # Check if column names exist and are all non-empty (meaningful)
        cnames <- colnames(thr)
        has_meaningful_colnames <- !is.null(cnames) && all(nzchar(cnames))

        if (has_meaningful_colnames) {
            # Use column names if they all exist and are non-empty
            thr.lab.text <- matrix(rep(cnames, each = nI), nrow = nI)
        } else if (!is.null(thr.lab.type) && thr.lab.type == "transition") {
            # Transition labels: 0/1, 1/2, 2/3, etc.
            nL <- ncol(thr)
            transition.labs <- paste0(seq_len(nL) - 1, "/", seq_len(nL))
            thr.lab.text <- matrix(rep(transition.labs, each = nI), nrow = nI)
        } else {
            # Default labels: 1, 2, 3, etc.
            thr.lab.text <- matrix(rep(seq_len(ncol(thr)), each = nI), nrow = nI)
        }
    }
    
    # Set default item labels if not provided
    if (is.null(label.items)) {
        if (!is.null(rownames(thr))) {
            label.items <- rownames(thr)
        } else {
            label.items <- paste("Item", seq_len(nI))
        }
    }
    
    # Set global plot margins and axis parameters
    par(oma = oma, mgp = c(2, 1, 0))
    
    # Create base plot without axes
    plot(seq_len(nI), rep(0, nI), type = "n", axes = FALSE, xlab = axis.items, 
         ylab = "", ylim = yRange, xlim = c(0.5, nI + 0.5), cex.lab = .8, 
         font.lab = 3)
    
    # Add cutpoints if provided, using 'cutpoints.par'
    if (!is.null(cutpoints)) {
        cutpoints.default <- list(col = "black", lwd = 1, lty = 2)
        cutpoints.par <- modifyList(cutpoints.default, cutpoints.par)
        abline(h = cutpoints, col = cutpoints.par$col, lwd = cutpoints.par$lwd, lty = cutpoints.par$lty)
    }

    box(bty = "o")
    
    # Draw logit axis based on user choice and customize using `axis.logits.par`
    if (show.axis.logits %in% c("R", TRUE)) {
        axis.logits.default <- list(side = 4, las = 1, cex.axis = axis.logits.cex, font.axis = 2)
        axis.logits.par <- modifyList(axis.logits.default, axis.logits.par)
        do.call(axis, axis.logits.par)
        
        logits.text.default <- list(text = axis.logits, side = 4, line = 1.5, cex = axis.logits.cex, font = 3)
        logits.text.par <- modifyList(logits.text.default, logits.text.par)
        do.call(mtext, logits.text.par)
    } else if (show.axis.logits == "L") {
        axis.logits.default <- list(side = 2, las = 1, cex.axis = axis.logits.cex, font.axis = 2)
        axis.logits.par <- modifyList(axis.logits.default, axis.logits.par)
        do.call(axis, axis.logits.par)
        
        logits.text.default <- list(text = axis.logits, side = 2, line = 1.5, cex = axis.logits.cex, font = 3)
        logits.text.par <- modifyList(logits.text.default, logits.text.par)
        do.call(mtext, logits.text.par)
    }
    
    # Draw vertical lines between min and max thresholds if 'vertLines' is TRUE
    if (vertLines == TRUE) {
        # Default vertical line style
        vertLines.default <- list(col = "grey90", lty = 1, lwd = 1)
        vertLines.par <- modifyList(vertLines.default, vertLines.par)
        
        # Ensure proper handling of NA values and matching lengths
        vertLines.data <- cbind(seq_len(nI), t(apply(thr, 1, function(row) range(row, na.rm = TRUE))))
        
        # Ensure no mismatch in dimensions
        if (nrow(vertLines.data) == nI) {
            apply(vertLines.data, 1, function(x) {
                if (!is.na(x[2]) && !is.na(x[3])) {
                    lines(c(x[1], x[1]), c(x[2], x[3]), col = vertLines.par$col, 
                          lty = vertLines.par$lty, lwd = vertLines.par$lwd)
                }
            })
        }
    }
    
    # Plot threshold symbols (using the additional flexibility from 'thr.sym.par')
    if (show.thr.sym) {
        thr.sym.default <- list(cex = thr.sym.cex, lwd = thr.sym.lwd, pch = thr.sym.pch, 
                                col = thr.sym.col.fg, bg = thr.sym.col.bg)
        thr.sym.par <- modifyList(thr.sym.default, thr.sym.par)
        points(row(thr), thr, type = "p", cex = thr.sym.par$cex, lwd = thr.sym.par$lwd, 
               pch = as.matrix(thr.sym.par$pch), col = as.matrix(thr.sym.par$col), 
               bg = as.matrix(thr.sym.par$bg))
    }
    
    # Add threshold labels (using the flexibility from 'thr.lab.par')
    if (show.thr.lab) {
        thr.lab.default <- list(labels = as.matrix(thr.lab.text), col = thr.lab.col, 
                                pos = thr.lab.pos, cex = thr.lab.cex, font = thr.lab.font)
        thr.lab.par <- modifyList(thr.lab.default, thr.lab.par)
        text(row(thr), thr, labels = thr.lab.par$labels, col = thr.lab.par$col, 
             pos = thr.lab.par$pos, cex = thr.lab.par$cex, font = thr.lab.par$font)
    }
    
    # Add item labels (using the flexibility from 'label.items.par')
    if (label.items.rows == 1) {
        label.items.default <- list(labels = label.items, srt = label.items.srt, 
                                    cex = label.items.cex, adj = if (label.items.srt != 0) c(1, 1) else c(0.5, 2))
        label.items.par <- modifyList(label.items.default, label.items.par)
        text(seq_len(nI), y = par("usr")[3] - 0.05, labels = label.items.par$labels, 
             srt = label.items.par$srt, adj = label.items.par$adj, 
             xpd = TRUE, cex = label.items.par$cex)
        if (label.items.ticks) {
            axis(1, at = seq_len(nI), labels = FALSE, line = NA, tcl = -0.35)
        }
    }
    
    # Add item labels for multiple rows (using flexibility from 'label.items.par')
    if (label.items.rows == 2) {
        odd_rows <- seq(1, nI, 2)
        even_rows <- seq(2, nI, 2)
        text(odd_rows, y = par("usr")[3], labels = label.items[odd_rows], adj = c(0.5, 2.4), 
             xpd = TRUE, cex = label.items.cex)
        text(even_rows, y = par("usr")[3], labels = label.items[even_rows], adj = c(0.5, 4.0), 
             xpd = TRUE, cex = label.items.cex)
        if (label.items.ticks) {
            axis(1, at = odd_rows, labels = FALSE, line = NA, tcl = -0.35)
            axis(1, at = even_rows, labels = FALSE, line = NA, tcl = -0.9)
        }
    }
}

make.deltas.default <-
function(item.params, cross.params = 0, step.params = 0, item.sign = 1, step.sign = 1, inter.sign = 1, ...) {
	#print(item.params)
	#print(step.params)
throlds <- item.params
	crosses <- cross.params
	steps <- step.params
	#print(throlds)
	#print(crosses)
	num.items <- length(throlds)
	if (length(steps) > 1) 
		steps <- matrix(steps, nrow = num.items, ncol = length(steps), byrow = TRUE)
	#print(steps)
	
	if (length(crosses) > 1) {
		item.nums <- 1:num.items
		full.steps <- matrix(nrow = max(item.nums), ncol = ncol(crosses))
		full.steps[, 2] <- 0

		full.steps[item.nums %in% unlist(crosses[1]), ] <- as.matrix(crosses)


		crosses <- full.steps[, -1]
	} else crosses <- 0
	#print(inter.sign)
	#print(item.sign)
	#print(step.sign)
	throlds <- crosses * inter.sign + throlds * item.sign + steps * step.sign
	throlds <- throlds[rowSums(!is.na(throlds)) != 0, ]

	return(throlds)


}

make.deltas.CQmodel <-
function(item.params, item.table = NULL, interactions = NULL, step.table = NULL, item.sign = NULL, inter.sign = NULL, 
	step.sign = NULL, ...) {
	RMP <- item.params$RMP
	if (is.null(item.table)) {
		parts <- unique(unlist(item.params$parts))
		#print(parts)
		if (length(parts) > 2) 
			stop("Please specify an item.table as well as the interactions and/or step.table")
		tables <- names(RMP)
		interactions.at <- grep("\\*", tables)
		if(length(interactions.at) > 0) {
		interactions <- tables[interactions.at]
		tables <- tables[-interactions.at]
		}
		item.table <- tables[1]
		if (length(tables) == 2) 
			step.table <- tables[2]
		else if (length(tables) > 2) 
			stop("Please specify tables")
	}

	eqn <- item.params$equation

	if (is.null(item.sign)) {
		item.sign <- ifelse(grepl(paste("-", item.table, sep = ""), eqn), -1, 1)
		#print(item.table)
		#print(eqn)
	}
	item.name <- ifelse(item.params$imported,"Parameters",item.table)
	#print(item.params$imported)
	item.table <- RMP[[item.table]]
	throlds = item.table$est
	throlds <- throlds[!is.na(throlds)]
	
		item.names <- unlist(item.table[item.name])
	
	if (item.name == "step") 
		item.names <- item.names[item.names != 0]

	if (!is.null(step.table) || !is.null(interactions)) {
	
		if (!is.null(step.table)) {
			if (is.null(step.sign)) {
				step.sign <- ifelse(grepl(paste("-", step.table, sep = ""), eqn), -1, 1)
			}
			step.name <- step.table
			step.table <- RMP[[step.table]]
			steps <- step.table$est
			steps <- steps[!is.na(steps)]
		} else {
			cross.parts <- unlist(strsplit(interactions, "\\*"))
			step.name <- cross.parts[cross.parts != item.name]
			steps <- 0
			step.sign <- 1
		}


		if (!is.null(interactions)) {
			if (is.null(inter.sign)) {
				inter.sign <- ifelse(grepl(paste("-", interactions, sep = ""), eqn), -1, 1)
			}
			inter.name <- interactions
			interactions <- RMP[[interactions]]
			if (step.name == "step") 
				step.col = "step"
			else step.col = paste("n", step.name, sep = "_")
			if (item.name == "step") 
				item.col = "step"
			else item.col = paste("n", item.name, sep = "_")

			crosses <- reshape(interactions[c(item.col, step.col, "est")], direction = "wide", timevar = step.col, idvar = item.col)
			crosses <- crosses[colSums(!is.na(crosses)) != 0]
			crosses <- crosses[rowSums(!is.na(crosses)) > 1, ]
			# find missing items, jerred bug
			if(!is.null(item.table)) {
				item.nums <- item.table[[1]]
				crosses[1] <- match(crosses[,1],item.nums)
				
			}
		} else {
			crosses <- 0
			inter.sign <- 1
		}
		throlds <- make.deltas(throlds, crosses, steps, item.sign, step.sign, inter.sign)
	
		if (!is.null(step.table)) 
			step.names <- unlist(step.table[step.name])
		else step.names <- unique(unlist(interactions[step.name]))
		if (step.name == "step") 
			step.names <- step.names[step.names != 0]
		colnames(throlds) <- step.names
		rownames(throlds) <- item.names
	}
	else
		names(throlds) <- item.names


	
	
	

	# message("Using ", item.name, ifelse(!is.null(interactions), paste(" and", inter.name), ""), ifelse(!is.null(step.table), paste(" and", 
		# step.name), ""), " tables to create delta parameters")

	return(throlds)

}

wrightMap <-
function(thetas, thresholds = NULL, item.side = itemModern, person.side = personHist,  main.title = "Wright Map", min.logit.pad = 0.25, max.logit.pad = 0.25, min.l = NULL, max.l = NULL, item.prop = 0.8, return.thresholds = TRUE, new.quartz = FALSE, use.hist = NULL, item.groups = NULL, item.group.cex = 0.6, axis.items.cex = 0.7, ...) {

	## Helper Functions


	if(is.null(thresholds))
		thresholds <- thetas

	thetas <- personData(thetas)

	thresholds <- itemData(thresholds,...)

	# Setting plot parameters
	thresholds <- as.matrix(thresholds)

	nD <- ncol(thetas)

	min.theta <- quantile(thetas, probs = c(0.01), na.rm = TRUE)
	max.theta <- quantile(thetas, probs = c(0.99), na.rm = TRUE)

	if (is.null(min.l)) {
		min.l <- min(c(min.theta, thresholds), na.rm = TRUE) - min.logit.pad
	}

	if (is.null(max.l)) {
		max.l <- max(c(max.theta, thresholds), na.rm = TRUE) + max.logit.pad
	}

	yRange <- c(min.l, max.l)

	# Generating Full Map

	if (new.quartz)
		dev.new(width = 9, height = 5)

	op <- par("oma", "mar", "mgp")

	#par(oma = op$oma + c(0, 5, 0, 5))
	par(mar = c(op$mar[1], 0.2, op$mar[3], 0.1))
	#par(mgp = c(op$mar[1] - 2.4, 1, 0))

	par(mar = c(op$mar[1], 0.2, op$mar[3], 0.1))
	left.marg <- 0.05
	right.marg <- .1
	plots <- 1 - (left.marg + right.marg)
	divider <- plots * (1 - item.prop) + left.marg
	person.screen <- c(left.marg,divider,0,1)
	item.screen <- c(divider,1 - right.marg,0,1)
	screens <- matrix(c(item.screen,person.screen),ncol = 4,byrow = TRUE)
	old.screens <- split.screen()
	split.screen(screens)
	item.screen <- screen()
	dots <- list(...)
	dots[c("yRange","oma")] <- NULL

	# Handle item groups for multiple panels
	if (!is.null(item.groups)) {
		# Convert to factor to get unique groups and preserve order
		if (!is.factor(item.groups)) {
			item.groups <- factor(item.groups, levels = unique(item.groups))
		}
		group.levels <- levels(item.groups)
		nG <- length(group.levels)
		nI <- nrow(thresholds)

		# Define parameters that need to be subset by item rows
		# Matrix parameters: rows = items, columns = steps/levels
		matrix.params <- c("thr.lab.text", "thr.sym.pch", "thr.sym.cex", "thr.sym.lwd",
		                   "thr.sym.col.fg", "thr.sym.col.bg", "thr.lab.col",
		                   "thr.lab.font", "thr.lab.pos")
		# Vector parameters: one element per item
		vector.params <- c("label.items")

		# Split item screen into multiple sub-panels (one per group)
		item.old.screens <- split.screen()
		split.screen(c(1, nG))
		first.item.screen <- screen()

		# Determine which panel is the middle one for the "Items" label
		middle.panel <- ceiling(nG / 2)

		for (i in seq_len(nG)) {
			group.name <- group.levels[i]
			group.idx <- which(item.groups == group.name)
			group.thr <- thresholds[group.idx, , drop = FALSE]

			# Preserve row names for item labels
			if (!is.null(rownames(thresholds))) {
				rownames(group.thr) <- rownames(thresholds)[group.idx]
			}

			# Use empty axis label - we'll add the group name separately with smaller font
			group.axis.items <- ""

			# Determine which logit axis to show
			# Only show on rightmost panel
			if (i == nG) {
				group.show.axis.logits <- if (!is.null(dots$show.axis.logits)) dots$show.axis.logits else "R"
			} else {
				group.show.axis.logits <- FALSE
			}

			# Build parameters for this group
			group.dots <- dots
			group.dots$axis.items <- group.axis.items
			group.dots$show.axis.logits <- group.show.axis.logits

			# Subset matrix parameters (rows = items) for this group
			for (param in matrix.params) {
				if (!is.null(group.dots[[param]])) {
					val <- group.dots[[param]]
					if (is.matrix(val) || is.data.frame(val)) {
						if (nrow(val) == nI) {
							group.dots[[param]] <- val[group.idx, , drop = FALSE]
						}
					}
				}
			}

			# Subset vector parameters (one per item) for this group
			for (param in vector.params) {
				if (!is.null(group.dots[[param]])) {
					val <- group.dots[[param]]
					if (is.vector(val) && length(val) == nI) {
						group.dots[[param]] <- val[group.idx]
					}
				}
			}

			# Handle per-panel cutpoints if cutpoints is a list
			if (!is.null(group.dots$cutpoints) && is.list(group.dots$cutpoints)) {
				cutpoints.list <- group.dots$cutpoints
				if (group.name %in% names(cutpoints.list)) {
					group.dots$cutpoints <- cutpoints.list[[group.name]]
				} else {
					# No cutpoints specified for this group
					group.dots$cutpoints <- NULL
				}
			}

			item.params <- list(thr = group.thr, yRange = yRange, oma = c(0, 0, 0, 0))
			do.call(item.side, c(item.params, group.dots))

			# Add group name below the panel
			mtext(group.name, side = 1, line = 2, font = 3, cex = item.group.cex)

			# Add shared "Items" label below the middle panel
			if (i == middle.panel) {
				mtext("Items", side = 1, line = 3.5, font = 3, cex = axis.items.cex)
			}

			# Move to next screen if not the last group
			if (i < nG && screen() != max(split.screen())) {
				screen(screen() + 1)
			}
		}

		# Clean up item sub-screens
		item.curr.screens <- split.screen()
		item.new.screens <- item.curr.screens[!(item.curr.screens %in% item.old.screens)]
		close.screen(item.new.screens)
	} else {
		# Original single-panel behavior
		item.params <- list(thr = thresholds, yRange = yRange, oma = c(0,0,0,0))
		do.call(item.side, c(item.params, dots))
	}

	# Only add title and outer margin if main.title is provided
	if (!is.null(main.title) && nchar(main.title) > 0) {
		par(oma = c(0, 0, 3, 0))
		mtext(main.title, side = 3, line = 1, outer = TRUE, font = 2)
	}
	close.screen(item.screen)
	if(!is.null(use.hist)) {
		message("Parameter 'use.hist' is deprecated. Please use 'person.side' parameter instead.")
		person.side <- ifelse(use.hist,personHist,personDens)
	}
	
	dots[c("axis.logits","show.axis.logits","close.on.close")] <- NULL
	person.params <- list(thetas = thetas,yRange = yRange,close.on.close = FALSE,oma = c(0,0,0,0),axis.logits = "",show.axis.logits = FALSE)
	do.call(person.side,c(person.params,dots))
	par(op)
	
	curr.screens <- split.screen()
	new.screens <- curr.screens[!(curr.screens %in% old.screens) ]
	close.screen(new.screens)
	
	if (return.thresholds) {
		return(thresholds)
	}



}

CQmodel <-
function(p.est = NULL, show = NULL, p.type = NULL, equation = NULL) {

	############Helper functions############
	

	breakup <- function(data, starts, titles) {
		ends = c(starts[-1], length(data))
		mapply(breakdown, titles, starts, ends, list(data), SIMPLIFY = FALSE)
	}


	breakdown <- function(title, m_sec1, m_sec2, shw) {
		shw[m_sec1:m_sec2]
	}


	RMP <- function(table, parts) {

		RMP.lengths = c(10, 9, 8, 6, 6, 6, 8, 6, 5, 6)
		RMP.titles = c("est", "error", "U.fit", "U.Low", "U.High", "U.T", "W.fit", "W.Low", "W.High", "W.T")

		titles <- as.list(as.data.frame(rbind(paste("n_", parts, sep = ""), parts), stringsAsFactors = FALSE))
		titles[parts == "step"] <- "step"
		titles <- unlist(titles)


		left.side.titles <- strsplit(table[5], "ESTIMATE")[[1]][1]

		parts.search <- parts

		parts.search[parts == 'step'] <- '(step|category)'

		line.seps <- numeric()
		
		for (i in 1:length(parts)) {

			temp.col.seps <- numeric()

			if (gregexpr(parts.search[i],left.side.titles)[[1]][1] - 2 > 0){

				temp.col.seps[1] <- gregexpr(parts.search[i],left.side.titles)[[1]][1] - 2
				#print(temp.col.seps)
				
				

				if (i > 1){

					# temp.col.seps[1] <- temp.col.seps[1] 
					# print(temp.col.seps)
	
					if(parts[i] != 'step' & parts[i] != 'category'){
						
						
	
						first.line <- substr(table[7], 1, temp.col.seps[1]+2)
						#print(first.line)
	
						number.col <- (nchar(first.line) - gregexpr("[0-9]+\\s+?$",first.line)[[1]][1] ) 
						#print(number.col)
	
						temp.col.seps[2] <- number.col
						temp.col.seps[1] <- temp.col.seps[1] - temp.col.seps[2] - sum(line.seps)
						
						#print(temp.col.seps)
						
						
	
					}else{

						temp.col.seps[1] <- temp.col.seps[1] - sum(line.seps)

					}



				}



			}



			if (i == 1){
	
				line.seps <- temp.col.seps
	
			}else{
	
				line.seps <- c(line.seps, temp.col.seps)
	
			}
	

		}

		if (length(line.seps)==0){

			line.seps <- nchar(left.side.titles)

		} else{

			line.seps <- c(line.seps,nchar(left.side.titles) - max(line.seps))

		}

		if (all(parts == 'step') & length(parts) == 1) {line.seps <- nchar(left.side.titles)}

		out = grep("^ *(Parameter )?[0-9]", table, value = TRUE)		
		out = gsub("[\\(\\)\\*,]", " ", out)
		out = trim(out)
		
		if(nchar(out[1]) < sum(RMP.lengths)) {
			out1 <- split.right(out, 10)
			multcols <- grep("[^ ] +[^ ]",out1[[2]])
			if(length(multcols) > 0) {
				RMP.lengths <- c(10,7)
				RMP.titles <- c("est","error")
			} else {
				RMP.lengths <- 10
				RMP.titles <- "est"
			}
		}
		out <- split.right(out, sum(RMP.lengths))
		
		if ( (all(parts == 'step') & length(parts) == 1) | imported) {

			left.table <- matrix(apply(out[1],1,function (x) gsub("^\\s+|\\s+$", "", x)), ncol=1)			
			colnames(left.table) <- parts

		}else{
			left.table <- read.fwf(tempify(out[1]), line.seps, col.names = titles, stringsAsFactors = FALSE)
			left.table[sapply(left.table, is.character)] <- sapply(left.table[sapply(left.table, is.character)],function (x) gsub("^\\s+|\\s+$", "", x))

		}


		right.table <- read.fwf(tempify(out[2]), RMP.lengths, col.names = RMP.titles, stringsAsFactors = FALSE)

		cbind(left.table, right.table)

	}
	
	wmap.items <- function(map) {
		m <- regexpr("\\|[0-9][0-9 ]+",map)
		x2 <- regmatches(map,m)
		m2 <- gregexpr("[0-9]+",x2)
		return(sort(as.numeric(unlist(regmatches(x2,m2)))))
	}


	split.right <- function(table, right) {
		maxchar <- max(sapply(table,nchar))
		left = maxchar - right
		tf <- tempfile()
		write(table, tf)
		out <- read.fwf(tf, c(left, right), stringsAsFactors=FALSE)
		out
	}

	tempify <- function(list) {
		tf <- tempfile()
		write(as.character(as.matrix(list)), tf)
		tf
	}
	
		make.GIN <- function(table) {
		if (length(table) == 5) {
			items <- as.vector(unlist(unique(table[5])))
			# if(class(items) != "character")
			if (!is(items, "character"))
				items <- paste("Item",items,sep="_")
			#print(items)
			#print(length(items))
			out <- mapply(by.item,items,c(1:length(items)), list(table[4]), list(table[2]), list(max(table[1])),SIMPLIFY=FALSE)
			#print(as.data.frame(out))
			return(t(as.data.frame(out)))
		} else {
			pieces <- as.character(unlist(unique(table[5])))
			return(mapply(break.GIN, pieces, list(table),SIMPLIFY=FALSE))
		}
	}

	break.GIN <- function(piece, table) {
		table <- table[table[5] == piece,]
		#print(make.GIN(table[-c(3, 4, 5)]))
		return(make.GIN(table[-c(3, 4, 5)]))
	}

	by.item <- function(name,item, ids, values, how.long) {

		vals <- values[ids == item]
		if (length(vals) < how.long) {
			extras <- c((length(vals) + 1):how.long)
			vals[extras] <- NA
		}
		vals

	}

	get.names <- function(type, table) {
		return(unique(table[type]))
	}

	split.by <- function(table, split) {
		out <- read.table(tempify(table), sep = split, stringsAsFactors = FALSE, strip.white = TRUE)
		row.names(out) <- t(rename(t(out[1])))
		out <- out[out$V2 != "", ]
		out <- as.list(as.data.frame(t(out[2]), stringsAsFactors = FALSE))
		out
	}

	trim <- function(x) gsub("^\\s+|\\s+$", "", x)

	safe.remove <- function(table, line.at) {
		if (length(line.at) > 0) {
			table <- table[-line.at]
		}
		table
	}

	make.label <- function(lab, dim) {
		return(paste(lab, " (", dim, ")", sep = ""))
	}

	make.labels <- function(labs, dims) {
		return(unlist(as.list(t(sapply(labs, make.label, dims)))))
	}

	reliabilities <- function(table) {
		table <- table[-grep("^Dimension:", table)]
		colons.at <- grep(":", table)
		colons <- table[colons.at]
		out <- split.by(colons, ":")
		out
	}

	numify <- function(table) {
		out <- table
		nums <- suppressWarnings(!is.na(as.numeric(table)))
		out[nums] <- as.numeric(table[nums])
		return(out)

	}

	rename <- function(titles) {
		titles[titles == "SUMMARY OF THE ESTIMATION"] <- "SOE"
		titles[titles == "TABLES OF RESPONSE MODEL PARAMETER ESTIMATES"] <- "RMP"
		titles[grepl("^IMPORTED MODEL", titles)] <- "RMP"
		titles[titles == "TABLES OF POPULATION MODEL PARAMETER ESTIMATES"] <- "PMP"
		titles[grepl("MAP OF .+ AND RESPONSE MODEL PARAMETER ESTIMATES", titles)] <- "MRM"
		titles[grepl("HORIZONTAL MAP OF .+ AND THRESHOLDS", titles)] <- "HMT"
		titles[grepl("MAP OF .+ AND THRESHOLDS", titles)] <- "MTH"
		titles[titles == "TABLES OF GIN Thresholds"] <- "GIN"
		titles[titles == "TABLES OF GIN Item Parameters"] <- "GIN.deltas"
		titles[titles == "Estimation method was"] <- "method"
		titles[titles == "Assumed population distribution was"] <- "distribution"
		titles[titles == "Constraint was"] <- "constraint"
		titles[titles == "The format"] <- "format"
		titles[titles == "The item model"] <- "equation"
		titles[titles == "Sample size"] <- "participants"
		titles[titles == "Final Deviance"] <- "deviance"
		titles[titles == "Total number of estimated parameters"] <- "parameters"
		titles[titles == "The number of iterations"] <- "iterations"
		titles[titles == "Termination criteria"] <- "criteria"
		titles[titles == "Random number generation seed"] <- "seed"
		titles[titles == "Number of nodes used when drawing PVs"] <- "PV.nodes"
		titles[titles == "Number of nodes used when computing fit"] <- "fit.nodes"
		titles[titles == "Number of plausible values to draw"] <- "n.plausible.values"
		titles[titles == "Maximum number of iterations without a deviance improvement"] <- "max.iterations.no.improvement"
		titles[titles == "Maximum number of Newton steps in M-step"] <- "max.steps"
		titles[titles == "Value for obtaining finite MLEs for zero/perfects"] <- "zero.perfect.value"
		titles[titles == "The regression model"] <- "regression"
		titles[titles == "key 1 scored as 1"] <- "key"
		titles[titles == "The Data File"] <- "data.file"

		titles[titles == "Max iterations"] <- "max.iterations"
		titles[titles == "Parameter Change"] <- "parameter.change"
		titles[titles == "Deviance Change"] <- "deviance.change"

		titles[titles == "REGRESSION COEFFICIENTS"] <- "reg.coef"
		titles[grepl("COVARIANCE/CORRELATION MATRIX", titles)] <- "cov.cor"
		titles[titles == "RELIABILITY COEFFICIENTS"] <- "rel.coef"

		titles
	}


	model <- list()
	if (!(is.null(show))) {
		#ptm <- proc.time()
		shw <- readLines(show)
		shw.starts = grep("^\f==", shw)
		if (length(shw.starts) == 0) {
			shw.starts = grep("^==", shw)
			shw.starts = shw.starts[(shw.starts + 3) %in% shw.starts]
			CQV = 3
		} else {
			CQV = 2
		}
		titles = shw[shw.starts + 2]
		if (length(grep("^IMPORTED MODEL", titles)) == 0) {
			imported = FALSE
		} else {
			imported = TRUE
		}

		shw.titles = rename(titles)


		model <- breakup(shw, shw.starts, shw.titles)
		model$imported <- imported
		
		#print(model)

		
		#######SOE####################
		
		#ptm <- proc.time()
		date.pattern <- "(?:(Sun|Mon|Tue|Wed|Thu|Fri|Sat)\\s+)?(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\\s+(0[1-9]|[1-2]?[0-9]|3[01])\\s+(2[0-3]|[0-1][0-9]):([0-5][0-9])(?::(60|[0-5][0-9]))?\\s+(19[0-9]{2}|[2-9][0-9]{3})+$"
		date.at <- grep(date.pattern, model[[1]])
		title.date <- model[[1]][date.at]
		model$SOE <- safe.remove(model$SOE, date.at)
		m <- regexpr(date.pattern, title.date)
		model$run.details <- list()
		#class(model$run.details) <- "details"
		date.string <- regmatches(title.date, m)
		model$run.details$date <- strptime(date.string, format = "%a %b %d %H:%M %Y")
		model$title <- trim(paste(unlist(regmatches(title.date, m, invert = TRUE)), collapse = ""))


		file.at <- grep("The Data File: ", model$SOE)
		file.line <- model$SOE[file.at]
		model$SOE <- safe.remove(model$SOE, file.at)
		m <- regexpr("The Data File: ", file.line)
		model$run.details$data.file <- trim(paste(unlist(regmatches(file.line, m, invert = TRUE)), collapse = ""))

		colons.at <- grep(":", model$SOE)
		other.lines <- model$SOE[-colons.at]
		colons <- model$SOE[colons.at]
		two.colons.at <- grep(":.+:", colons)
		other.lines <- append(other.lines, colons[two.colons.at])
		colons <- safe.remove(colons, two.colons.at)
		
		if(!is.null(colons)) {

			SOE <- split.by(colons, ":")
	
			other.lines <- other.lines[-grep("===", other.lines)]
			other.lines <- other.lines[other.lines != ""]
			other.lines <- other.lines[other.lines != "SUMMARY OF THE ESTIMATION"]
			other.lines <- trim(other.lines)
	
			reason.at <- grep("Iterations terminated because", other.lines)
			SOE$termination.reason <- other.lines[reason.at]
			other.lines <- safe.remove(other.lines, reason.at)
	
			deviance.line <- grep("Deviance Change=", other.lines, value = TRUE)
			other.lines <- other.lines[-grep("Deviance Change=", other.lines)]
			termination.criteria <- c(unlist(strsplit(SOE$criteria, ",")), deviance.line)
			SOE <- c(SOE, split.by(termination.criteria, "="))
			SOE$criteria <- NULL
	
			model$run.details$format <- SOE$format
			model$run.details$key <- SOE$key
			model$run.details <- c(model$run.details, other.lines)
			SOE <- numify(SOE)
	
			model <- c(SOE["equation"], SOE["participants"], SOE["deviance"], SOE["parameters"], model)
			class(SOE) <- "SOE"
	
	
			model$SOE <- SOE
		
		}
		
		if(is.null(model$equation)) {
			if(is.null(equation)) {
				stop("Please specify the model equation.")
			} else {
				model$equation <- equation
			}
		}
		
		
		
		##############RMP######################
		


		additive.parts = unlist(strsplit(model$equation, "[+|-]"))
		parts = strsplit(additive.parts, "\\*")
		model$additive.parts <- additive.parts
		model$parts <- parts
		
		if (imported) {
			params <- RMP(model$RMP, "Parameters")
			model$RMP <- list()
			model$RMP$item <- params
		} else {
			RMP.tables <- breakup(model$RMP, grep("  VARIABLES", model$RMP) - 2, additive.parts)
			model$RMP = mapply(RMP, RMP.tables, parts, SIMPLIFY = FALSE)
			model$run.details$names <- mapply(get.names, parts[parts == additive.parts], model$RMP[parts == additive.parts])
		}
		
		
		
		#print(model$RMP)
		

		##########PMP###########
		if(!is.null(model$PMP)) {
		PMP.starts <- grep("^====+", model$PMP)
		PMP.heads <- grep(date.string, model$PMP)
		PMP.starts <- PMP.starts[!(PMP.starts + 1) %in% PMP.heads]
		PMP.titles <- rename(trim(paste(model$PMP[PMP.starts + 1], model$PMP[PMP.starts + 2], sep = "")))
		PMP <- breakup(model$PMP, PMP.starts, PMP.titles)
		variance.line = grep("Variance", PMP$cov.cor, value = TRUE)
		m <- gregexpr("[0-9]+\\.[0-9]+(?![0-9])(?![\\s]*\\))", variance.line, perl = TRUE)
		PMP$variances <- as.numeric(unlist(regmatches(variance.line, m)))
		m <- gregexpr("[0-9\\.\\-#IO]+(?=[\\s]*\\))", variance.line, perl = TRUE)
		errors <- as.numeric(unlist(regmatches(variance.line, m)))
		PMP$nDim = length(PMP$variances)
		length(errors) <- length(PMP$variances)
		PMP$dimensions = "Main dimension"
		if (PMP$nDim > 1) {

			if (CQV == 2){
				
				PMP$cov.cor <- read.fwf(tempify(PMP$cov.cor[8:(8 + PMP$nDim - 1)]), widths = c(25, rep(9, PMP$nDim)), row.names = 1, 
				strip.white = TRUE, stringsAsFactors = FALSE)
				
			}
			
			if (CQV == 3){
				
				PMP$cov.cor <- read.fwf(tempify(PMP$cov.cor[8:(8 + PMP$nDim - 1)]), widths = c(25, rep(18, PMP$nDim)), row.names = 1, 
				strip.white = TRUE, stringsAsFactors = FALSE)
				
			}

			PMP$dimensions <- row.names(PMP$cov.cor)
			names(PMP$cov.cor) <- PMP$dimensions
			PMP$cor.matrix <- PMP$cov.cor
			PMP$cor.matrix[upper.tri(PMP$cor.matrix)] = t(PMP$cor.matrix)[upper.tri(t(PMP$cor.matrix))]
			diag(PMP$cor.matrix) = 1
			PMP$cov.matrix <- PMP$cov.cor
			PMP$cov.matrix[lower.tri(PMP$cov.matrix)] = t(PMP$cov.matrix)[lower.tri(t(PMP$cov.matrix))]
			diag(PMP$cov.matrix) <- PMP$variances
		}
		if (length(errors) > 0) {
			PMP$variances <- cbind(PMP$variances, errors)
		}
		PMP$cov.cor <- NULL

		PMP$reg.coef = gsub("[\\(\\),]", " ", PMP$reg.coef)
		start <- grep("CONSTANT", PMP$reg.coef)
		end <- grep("^--+$", PMP$reg.coef) - 1
		PMP$reg.coef <- read.table(tempify(PMP$reg.coef[start:end]), stringsAsFactors = FALSE, strip.white = TRUE, row.names = 1)
		if (ncol(PMP$reg.coef) == PMP$nDim) {
			names(PMP$reg.coef) <- PMP$dimensions
		} else if (ncol(PMP$reg.coef) == 2 * PMP$nDim) {
			names(PMP$reg.coef) <- unlist(as.list(as.data.frame(rbind(PMP$dimensions, "S. errors"), stringsAsFactors = FALSE)))
		}
		PMP$reg.coef <- t(PMP$reg.coef)

		rel.starts <- grep("Dimension:", PMP$rel.coef)
		PMP$rel.coef <- breakup(PMP$rel.coef, rel.starts, PMP$dimensions)
		PMP$rel.coef <- sapply(PMP$rel.coef, reliabilities)
		PMP$rel.coef <- numify(PMP$rel.coef)
		PMP$rel.coef[PMP$rel.coef == "Unavailable"] <- NA
		PMP$rel.coef <- t(PMP$rel.coef)

		model$PMP <- NULL
		model <- c(model, PMP)
		
		}
		
		##########MRM############
		
		maps <- model[names(model) == "MRM"]
		if(length(maps) > 1) {
		model[names(model) == "MRM"] <- NULL
		model$MRM <- maps[1]
		model$MRM.dim <- maps[-1]
		names(model$MRM.dim) <- model$dimensions
		
		model$dim.items <- sapply(model$MRM.dim,wmap.items)
		}


		########GIN#########
		
		do.GIN <- function(GIN) {
			
			GIN <- GIN[4:(length(GIN))]
			GIN <- GIN[-grep("===",GIN)]
			GIN <- GIN[-grep("GIN Number", GIN)]
			GIN <- GIN[-grep("---",GIN)]

			GIN <- gsub("\\s*\t\\s*", "\t", GIN)
			GIN <- gsub(" +","_",GIN)
			GIN <- gsub("^[0-9\\.]+\\.", "", GIN)
			GIN <- read.delim(tempify(GIN),header=FALSE)
			
			GIN <- GIN[colSums(!is.na(GIN))!=0]
			return(make.GIN(GIN))
		}
		
		
		if (!is.null(model$GIN)) {
			model$GIN <- do.GIN(model$GIN)
		}
		
		
		if(!is.null(model$GIN.deltas)) {
			model$GIN.deltas <- do.GIN(model$GIN.deltas)
		}
		
		#return(proc.time()-ptm)
		class(model) <- "CQmodel"

	}



	#######Person Parameters#############
	
	if (!is.null(p.est)) {

		if (is.null(p.type)) {
			eaps <- unlist(strsplit(p.est, "[.]"))
			p.type <- toupper(eaps[length(eaps)])
		}

		p.est <- na.omit(read.table(p.est, stringsAsFactors = FALSE, fill = TRUE))

		if (p.type == "EAP") 
			colperdim = 3
		else colperdim = 4

		model$nDim = floor((length(p.est) - 1)/colperdim)

		if (is.null(model$dimensions) || length(model$dimensions != model$nDim)) 
			model$dimensions <- paste("d", c(1:model$nDim), sep = "")

		if (p.type == "EAP") {
			pp_lab_t <- make.labels(c("est", "error", "pop"), model$dimensions)
		} else {
			pp_lab_t <- c(make.labels(c("sscore", "max"), model$dimensions), make.labels(c("est", "error"), model$dimensions))
		}


		if (length(p.est)%%colperdim == 1) {
			names(p.est) <- c("casenum", pp_lab_t)
		} else if (p.type != "WLE") {
			names(p.est) <- c("casenum", "pid", pp_lab_t)
		} else if (length(p.est)%%colperdim == 3) {
			names(p.est) <- c("casenum","pid", pp_lab_t, "case.fit")
		} else if (any(p.est[4] < p.est[3])) {
			names(p.est) <- c("casenum", pp_lab_t, "case.fit")
		} else {
			names(p.est) <- c("casenum", "pid", pp_lab_t)
		}
		
		

		model$p.est <- p.est
		model$p.est.type <- p.type

	}

	class(model) <- "CQmodel"
	return(model)

}

fitgraph.CQmodel <-
function(fitEst,table = NULL,fit.type = "W",itemLabels =NULL,...) {
	#message(table)
	if(is.null(table))
		table.num <- 1
	else
		table.num <- match(table,names(fitEst$RMP))
	table <- fitEst$RMP[[table.num]]
	estlabel <- paste(fit.type,"fit",sep=".")
	llabel <- paste(fit.type,"Low",sep=".")
	ulabel <- paste(fit.type,"High",sep=".")
	
	if(is.null(itemLabels)) {
		#message(table.num)
		colNames <- unlist(strsplit(names(fitEst$RMP)[table.num],"*",fixed = TRUE))
		#message(colNames)
		itemLabels <- do.call(paste,table[colNames])
	}
	fitgraph(unlist(table[estlabel]),unlist(table[llabel]),unlist(table[ulabel]),itemLabels)
}

cutLines <- function(cutpoints = NULL,cut.left = 0, cut.right = 1, cut.lab.text = NULL, cut.lab.adj = c(0,1),...) {
	
	if(!is.null(cutpoints)) {
		
		width <- par("usr")[2]
	
	segments(cut.left * width,cutpoints,cut.right * width, col = 'grey70', lwd = 1.5, lend = 2)
		
		text(width *(.01  + cut.lab.adj[1] * .98),cutpoints + (.5 - cut.lab.adj[2])*.1,labels = cut.lab.text,cex= .6, adj = cut.lab.adj)
		
		}
}

sim.PCM <- function(pN, iN, lN, itemLevels = NULL, delta = NULL, delta.l = NULL, theta = NULL) {
    # Function to simulate polytomous item responses with items having varying levels
    #
    # Arguments:
    # pN        - Number of people (respondents)
    # iN        - Number of items
    # lN        - Default number of levels for the polytomous items (e.g., Likert scale levels)
    # itemLevels - Optional vector specifying the number of levels for each item (length = iN)
    # delta     - Optional matrix of item thresholds (iN x max(lN)). If not provided, it is generated
    # delta.l   - Optional vector of common level thresholds (max(lN)-1). If not provided, it is generated
    # theta     - Optional vector of person abilities. If not provided, it is generated from a standard normal distribution

    # Ensure valid values for iN and lN
    if (lN < 2) stop("Error: 'lN' (number of levels) must be greater than or equal to 2.")
    if (iN < 1) stop("Error: 'iN' (number of items) must be greater than or equal to 1.")

    # If itemLevels is not provided, assume all items have the same number of levels (lN)
    if (is.null(itemLevels)) {
        itemLevels <- rep(lN, iN)  # Default all items to have lN levels
    }

    # Ensure theta (person abilities) is provided or generate it
    if (is.null(theta)) {
        theta <- rnorm(pN, mean = 0, sd = 1)  # Default normal distribution for person abilities
    }

    # Check if delta (item thresholds) is provided
    if (is.null(delta)) {
        # If delta is not provided, generate common level thresholds (delta.l)
        if (is.null(delta.l)) {
            delta.l <- sort(runif((max(itemLevels) - 1), min = -3, max = 3))  # Common level thresholds
        }

        # Generate item-specific deviations for thresholds
        delta.il <- matrix(runif(iN * (max(itemLevels) - 1), min = -.5, max = .5), 
                           ncol = (max(itemLevels) - 1))
        delta.il <- t(t(delta.il) - colMeans(delta.il))  # Center the item deviations

        # Construct the full delta matrix (item thresholds)
        delta <- matrix(NA, iN, max(itemLevels))
        delta[, 2:max(itemLevels)] <- t(delta.l + t(delta.il))  # Combine common level thresholds and item-specific deviations
        delta[, 1] <- 0  # Ensure the first column is 0 for each item
    } else {
        # If delta is provided as a vector, convert it to a single-column matrix
        if (is.vector(delta)) {
            delta <- matrix(delta, ncol = 1)
        }
        
        # Check if the number of rows in delta matches iN (number of items)
        if (nrow(delta) != iN) {
            stop(paste("Error: The number of rows in 'delta' (", nrow(delta), 
                       ") must match the number of items (", iN, ").", sep = ""))
        }

        # Ensure the first column of delta contains 0s
        if (!all(delta[, 1] == 0)) {
            # Prepend a column of 0s if the first column isn't all 0s
            delta <- cbind(0, delta)
        }
    }

    # Adjust delta based on item levels (set extra thresholds to NA for items with fewer levels)
    for (i in 1:iN) {
        if (itemLevels[i] < max(itemLevels)) {
            delta[i, (itemLevels[i] + 1):max(itemLevels)] <- NA
        }
    }

    # Generate uniform random values for response generation
    U <- matrix(runif(pN * iN, 0, 1), ncol = iN)
    resp <- matrix(NA, pN, iN)

    M <- list()
    CM <- list()

    # Build M and CM matrices for each item (logits and cumulative probabilities)
    for (i in 1:iN) {
        M[[i]] <- matrix(NA, pN, max(itemLevels))
        CM[[i]] <- matrix(NA, pN, max(itemLevels))

        for (j in 1:pN) {
            M[[i]][j, 1] <- 0
            CM[[i]][j, 1] <- 1

            for (k in 2:itemLevels[i]) {
                M[[i]][j, k] <- M[[i]][j, k - 1] + theta[j] - delta[i, k]
                CM[[i]][j, k] <- CM[[i]][j, k - 1] + exp(M[[i]][j, k])
            }
        }
    }

    # Generate responses based on the cutpoints in CM
    for (i in 1:iN) {
        for (j in 1:pN) {
            cutpoint <- U[j, i] * CM[[i]][j, sum(!is.na(delta[i, ]))]
            found <- 0

            for (k in 1:sum(!is.na(delta[i, ]))) {
                if (cutpoint < CM[[i]][j, k] & found == 0) {
                    resp[j, i] <- k
                    found <- 1
                }
            }
        }
    }

    # Prepare the output as a list
    output <- list()
    output[['pN']] <- pN  # Number of people
    output[['iN']] <- iN  # Number of items
    output[['lN']] <- lN  # Default number of levels
    output[['itemLevels']] <- itemLevels  # Specific levels for each item
    output[['M']] <- M  # Logits for each person/item/level
    output[['CM']] <- CM  # Cumulative probabilities for each person/item/level
    output[['U']] <- U  # Random uniform values used for response generation
    output[['theta']] <- theta  # Person abilities

    if (!is.null(delta.l)) {
        output[['delta.l']] <- delta.l  # Common level thresholds
        output[['delta.il']] <- delta.il  # Item-specific deviations for thresholds
    }

    output[['delta']] <- delta  # Full item thresholds matrix
    output[['resp']] <- resp  # Simulated responses

    return(output)
}

difplot.CQmodel <- function(data, table.name = NULL, grouptype = NULL, group = NULL, ...) {
	RMP <- data$RMP
	if (is.null(table.name)) {
		if (is.null(grouptype)) {
			if (is.null(group)) {
				table.at <- grep("(?<!^step)\\*(?!step$)", names(RMP), perl = TRUE)[1]
				table <- RMP[[table.at]]
				if (is.null(table)) 
					stop("No table of the form [factor]*[factor] found")
			} else {
				tables <- RMP[grep(paste("\\b", group, "\\b", sep = ""), RMP)]
				table.at <- grep("(?<!\\bstep)\\*(?!step\\b)", names(tables), perl = TRUE)[1]
				table <- tables[[table.at]]
				if (is.null(table)) 
					stop(paste("No table of the form [factor]*[factor] containing the group \"", group, "\" found", 
						sep = ""))
			}

		} else {
			table.at <- grep(paste("(?<!\\bstep)\\*", grouptype, "\\b|\\b", grouptype, "\\*(?!step\\b)", sep = ""), 
				names(RMP), perl = TRUE)[1]
			table <- RMP[[table.at]]
			if (is.null(table)) 
				stop(paste("No table of the form [factor]*", grouptype, " found", sep = ""))

		}
	} else {
		table.name2 <- gsub("\\*", "\\\\*", table.name)
		table.at <- grep(paste("^", table.name2, "$", sep = ""), names(RMP))[1]
		table <- RMP[[table.at]]
		if(is.null(table))
			stop(paste("No table named \'",table.name,"\'found",sep=" "))
	}
	difplot(table, grouptype, group, ...)
}

	ICCfit <- function( itemNumber, observedResponses, personEstimates, itemParameters
		, xlim = c(-4,4), method = "Quantile", NQtiles = 10){

		propCI <- function(propVector, nVector, alpha = .05){

			propSE <- sqrt(propVector*(1-propVector)/nVector)

			propLB <- propVector - (propSE * qnorm(1-(alpha/2)))
			propUB <- propVector + (propSE * qnorm(1-(alpha/2)))

			data.frame(propSE = propSE, propLB = propLB, propUB = propUB)

		}

		plotICC <- function(difficulty, range = xlim){

			invlogit <- function(x) 
			{
				1/(1 + exp(-x))
			}

			params <- data.frame(ability = seq(-4,4, length.out = 1000), difficulty = difficulty)

			probs <- invlogit(params[,1]-params[,2])

			lines(params[,1],probs)

		}


		plotICCerrors <- function(difficulty, dSE, range = xlim){

			invlogit <- function (x) 
			{
				1/(1 + exp(-x))
			}

			params <- data.frame(ability = seq(-4,4, length.out = 1000)
				, lb  = difficulty - 1.96 * dSE
				, ub  = difficulty + 1.96 * dSE)

			probslb <- invlogit(params[,1]-params[,2])
			probsub <- invlogit(params[,1]-params[,3])

			xCoords <- c(ability = seq(-4,4, length.out = 1000),ability = seq(4,-4, length.out = 1000))
			yCoords <- c(probslb,rev(probsub) )

			polygon(xCoords,yCoords, col = "grey75", border = NA)

		}

		if(method == "ByPersonEstimate"){

			aggdata <- aggregate(observedResponses,
				by=list(round(personEstimates,2)), FUN = mean, na.rm = TRUE)

			aggdata[,-1][aggdata[,-1] == 1] <- .999
			aggdata[,-1][aggdata[,-1] == 0] <- .001

			sampleSizeAggdata <- aggregate(is.na(observedResponses), 
				by=list(round(personEstimates,2)), FUN = length)

		}

		if(method == "Quantile"){

			cutPoints <- quantile(personEstimates,seq(0,1,length = NQtiles + 1))

			aggdata <-aggregate(observedResponses, by=list(cut(personEstimates,cutPoints)), 
			  FUN=mean, na.rm=TRUE)

			breakMeans <-aggregate(personEstimates, by=list(cut(personEstimates,cutPoints)), 
			  FUN=mean, na.rm=TRUE)

			aggdata[,1] <- breakMeans[,2]

			aggdata[,-1][aggdata[,-1] == 1] <- .999
			aggdata[,-1][aggdata[,-1] == 0] <- .001

			sampleSizeAggdata <- aggregate(is.na(observedResponses), 
				by=list(cut(personEstimates,cutPoints)),  FUN = length)

			sampleSizeAggdata[,1] <- breakMeans[,2]

		}


		if(method == "Histogram"){

			histData <- hist(personEstimates, breaks = "FD", plot = FALSE)

			cutPoints <- histData$breaks

			aggdata <-aggregate(observedResponses, by=list(cut(personEstimates,cutPoints)), 
			  FUN=mean, na.rm=TRUE, drop = FALSE)

			breakMeans <-aggregate(personEstimates, by=list(cut(personEstimates,cutPoints)), 
			  FUN=mean, na.rm=TRUE, drop = FALSE)

			aggdata[,1] <- histData$mids

			aggdata[,-1][aggdata[,-1] == 1] <- .999
			aggdata[,-1][aggdata[,-1] == 0] <- .001

			sampleSizeAggdata <- aggregate(is.na(observedResponses), 
				by=list(cut(personEstimates,cutPoints)),  FUN = length, drop = FALSE)

			sampleSizeAggdata[,1] <- histData$mids

		}

		plot(aggdata[,1],aggdata[,itemNumber + 1]
			, type = "n", axes = FALSE,
			, ylab = "Proportion"
			, xlab = "Proficiency"
			, ylim = c(0,1)
			, xlim = xlim)

		plotICCerrors(itemParameters[itemNumber,1], itemParameters[itemNumber,2])

		plotICC(itemParameters[itemNumber,1])

		cbind(aggdata[,1],propCI(aggdata[,itemNumber + 1],sampleSizeAggdata[,itemNumber + 1]))

		apply(cbind(aggdata[,1],propCI(aggdata[,itemNumber + 1],sampleSizeAggdata[,itemNumber + 1]))
			,1,
			function(x) segments(x0 = x[1], y0 = x[3], x1 = x[1], y1 = x[4]
					, col = "#31333450"))

		points(aggdata[,1],aggdata[,itemNumber + 1], pch = 18, cex = .75, col = "#31333450")

		axis(2, las = 1)
		axis(1)

		title(paste("Item", rownames(itemParameters)[itemNumber]) )

		print(sampleSizeAggdata)

	}

difplot.default <- function(data, grouptype = NULL, group = NULL, item.names = NULL, ylim = c(-1, 
	1), ylab = NULL, ...) {
		
	table <- data

	if (is.null(group)) {
		if (is.null(grouptype)) {
			columns <- table[grep("^n_", names(table)) + 1]
			columns <- sapply(columns, unique,simplify = FALSE)
			columns <- sapply(columns, length)
			columns <- sort(columns)
			grouptype <- names(columns[1])
		}

		group <- table[grouptype][1, ]

	} else if (is.null(grouptype)) {
		grouptype <- names(table)[grep(paste("\\b", group, "\\b", sep = ""), table)[1]]
	}
	
	m <- table[grouptype] == group

	if (is.null(item.names)) {
		columns <- table[grep("\\bn_", names(table)) + 1]
		columns <- columns[-grep(paste("\\b", grouptype, "\\b", sep = ""), names(columns))]
		item.names <- columns[m, 1]
	}
	
	if(is.null(ylab))
		ylab <- paste0("Estimates of ",grouptype," effects (",group,")")
	
	plotCI(table$est[m], table$error[m], item.names, ylim = ylim, ylab = ylab, ...)
}

personDens <-
function(thetas, yRange = NULL, dim.lab.cex = 0.6, dim.lab.side = 3, dim.lab.adj = 0.5,dim.names = NULL,dim.color = "black",person.points = NULL, person.range = NULL, p.point.col = "black", p.range.col = "gray70",oma = c(0, 5, 0, 5), axis.logits = "Logits",show.axis.logits = TRUE, axis.persons = "Respondents",...) {

	densExt <- function(densElem) {
		xDim <- densElem["y"][[1]]
		yDim <- densElem["x"][[1]]
		xDim <- xDim/max(xDim)

		densInfo <- cbind(xDim, yDim)
		return(densInfo)
	}

	theta.dens <- function(thetas) {
		densList <- apply(thetas, 2, density, na.rm = TRUE)
		distInfo <- lapply(densList, densExt)

		return(distInfo)
	}

	person.plot <- function(distInfo, yRange, xRange, p.points, p.range, p.col, r.col, dim.lab.side, dim.lab.cex, dim.lab.adj, p.cex.lab, p.font.lab, p.lwd, cex) {
		par(mar = c(op$mar[1], 0.2, op$mar[3], 0.1))
		
		plot(distInfo, ylim = yRange, xlim = xRange, type = "l", axes = FALSE, ylab = "", xlab = "", cex.lab = p.cex.lab, font.lab = p.font.lab, lwd = p.lwd, col = attr(distInfo, "dim.color"))
		if(screen() == first)
			mtext(axis.persons, side = 2, line = 1, cex = 0.8, font = 3)
		mtext(attr(distInfo, "dim.name"), side = dim.lab.side, line = -1, cex = dim.lab.cex, font = 1, adj = dim.lab.adj)
		box(bty = "c")
		
		draw.range <- function(upper, lower, col) {
				
				points( c( 0,0), c(lower, upper), type = "l", lwd = 5, lend=2, col = col)
			}
			
		draw.point <- function(pt, col) {
				
				 points(0,pt, pch = 15, cex = .6, col = col)
			}

		 if(!is.null(p.range)) {
				p.range <- matrix(p.range,nrow = 2)
				lower <- p.range[1,]
				upper <- p.range[2,]
				mapply(draw.range,upper,lower,r.col)
			}
			if(!is.null(p.points)) {
				mapply(draw.point,p.points,p.col)
			}
		 
		if (screen() != max(split.screen())) 
			screen(screen() + 1)
	}
	
	thetas <- as.matrix(thetas)
	
	nD <- ncol(thetas)
	if(is.null(yRange))
		yRange <- c(min(thetas),max(thetas))

	xRange <- c(1, 0)
	distInfo <- theta.dens(thetas)
	
	if (is.null(dim.names)) {
		if (!is.null(names(thetas))) {
			dim.names <- names(thetas)
		} else if (nD == 1) {
			dim.names <- ""
		} else {
			dim.names <- c(paste("Dim", seq(1:nD), sep = ""))
		}
	}
	
	if (ncol(thetas) > 1 & length(dim.color) == 1) {
		dim.color <- rep(dim.color, ncol(thetas))
	}
	
	for (i in 1:nD) {
		attr(distInfo[[i]], "dim.name") <- dim.names[i]
		attr(distInfo[[i]], "dim.color") <- dim.color[i]
	}
	old.screens <- split.screen()
	split.screen(c(1, nD))
	first <- screen()

	op <- par("mar","oma")

	par(oma = oma)

		lapply(distInfo, FUN = person.plot, yRange = yRange, xRange = xRange, p.points = person.points, p.range = person.range, p.col = p.point.col, r.col = p.range.col, dim.lab.cex = dim.lab.cex, dim.lab.side = dim.lab.side, dim.lab.adj = dim.lab.adj, p.cex.lab = 1.3, p.font.lab = 3, p.lwd = 2, cex = 1.5)
		
		if (show.axis.logits) {
		axis(4, las = 1, cex.axis = 0.7, font.axis = 2)
	}
	mtext(axis.logits, side = 4, line = 1.5, cex = 0.8, font = 3)
	
	curr.screens <- split.screen()
	new.screens <- curr.screens[!(curr.screens %in% old.screens) ]
	close.screen(new.screens)
}

make.thresholds.matrix <- function(item.params, design.matrix = "normal", make.from = "deltas", theta.interval = c(-10, 10), throld = 0.5, 
	alpha = 1, c.params = 0, ...) {
	#print("matrix")
	
	# Provides a predicted probability of a given response for a polytomous
	# item. Mostly used in other functions.

	predicted.prob = function(theta, response, design.matrix, parameters, slope) {
		numerator =  exp(slope * (theta * (response - 1) + sum(parameters * design.matrix[response, ])))
		denominator = 0
		for (k in 1:nrow(design.matrix)) {
			denominator = denominator + exp(slope * (theta * (k - 1) + sum(parameters * design.matrix[k, ])))
		}
		return(numerator/denominator)
	}

	throlds.minimize = function(theta, threshold, slope) {
		numerator = exp(slope * (theta - threshold))
		denominator = 1 + exp(slope * (theta - threshold))
		prob <- numerator/denominator
		return((prob - throld)^2)
	}

	# The function passed to R's 'optimize' function. Finds the cumulative
	# predicted probability of a response, then returns (predict P - .5)^2.
# Minimizing this function finds the Thurstone threshold.
minimize.fun = function(theta, response, design.matrix, parameters, slope, guess) {
		max.score = nrow(design.matrix)
		categories = max.score:response
		predictions = rep(NA, times = max.score)
		for (x in categories) {
			predictions[x] = guess + (1 - guess) * predicted.prob(theta, x, design.matrix, parameters, slope)
		}
		total = sum(predictions, na.rm = TRUE)
		sq.err = (total - throld)^2
		return(sq.err)
	}

	# First creates an item design matrix if one not provided. Options
	# are "normal", "conquest", and an actual matrix. Then minimizes
# 'minimize.fun' for each threshold for the item.
get.thresholds = function(parameters, design.matrix = "normal", theta.interval = c(-10, 10), slope, guess) {
		#print(parameters)
		#print("get")
		parameters = as.numeric(parameters)
		max.length <- length(parameters)
		parameters = parameters[!is.na(parameters)]
		n.parameters = length(parameters)
		thresholds = rep(NA, times = max.length)
		if(make.from == "deltas") {
		
		n.categories = n.parameters + 1

		if (is.character(design.matrix)) {
			if (design.matrix == "conquest") {
				design.matrix = matrix(0, ncol = n.parameters, nrow = n.categories)
				design.matrix[, 1] = -1 * (1:n.categories - 1)
				i = 2
				while (i <= n.categories - 1) {
					design.matrix[i, 2:i] = -1
					i = i + 1
				}
			} else {
				design.matrix = matrix(0, ncol = n.parameters, nrow = n.categories)
				i = 2
				while (i <= n.categories) {
					design.matrix[i, 1:(i - 1)] = -1
					i = i + 1
				}
			}
			#print(design.matrix)
			}


		for (response in 2:n.categories) {
			opti = optimize(minimize.fun, interval = theta.interval, response = response, design.matrix = design.matrix, parameters = parameters, 
				slope = slope, guess = guess)
			thresholds[response - 1] = opti$minimum
			if (opti$objective > 10^(-5)) 
				message(paste("objective = ", opti$objective))
		}
		}
		else if(make.from == "thresholds"){
			for (response in 1:n.parameters) {
				opti <- optimize(throlds.minimize,interval = theta.interval, threshold = parameters[response], slope = slope)
				thresholds[response] <- opti$minimum
				if (opti$objective > 10^(-5)) 
				message(paste("objective = ", opti$objective))
				
			}
		}

		return(thresholds)

	}

	# Accepts a matrix of item parameters (rows are items) and feeds the items
	# to 'get.thresholds'. NAs are fine in the parameter.matrix, allowing
# items to have differing numbers of categories. design.matrix may be a
# single choice for all items or a list of matrices, one for each item.
apply.thresholds = function(parameter.matrix, design.matrix = "normal", theta.interval = c(-10, 10), slope = slope, guess = guess) {


		threshold.matrix <- as.matrix(mapply(get.thresholds, as.data.frame(t(parameter.matrix)), t(design.matrix), slope = slope, guess = guess, MoreArgs = list(theta.interval = theta.interval)))
		if (NCOL(threshold.matrix) > 1) 
			threshold.matrix <- t(threshold.matrix)

		return(threshold.matrix)

	}
	if(any(c.params != 0)) {
		if(make.from != "deltas")
			stop("Cannot run 3PL using threshold inputs")
		if(NCOL(item.params) != 1)
			stop("Cannot run polytomous 3PL")
	}
	if(make.from == "deltas")
		message("Assuming partial credit model")
	else if(make.from == "thresholds")
		message("Assuming graded response model")

	return(apply.thresholds(item.params, design.matrix, theta.interval, alpha, c.params))


}

itemData.CQmodel <- function(thresholds, item.table = NULL, interactions = NULL, step.table = NULL, item.type = "default", throld = 0.5, 
	...) {

	unpack.GIN <- function(GIN) {
		# if (class(GIN) == "matrix") 
		if (is(GIN, "matrix"))
			return(GIN)
		else {
			return(do.call(cbind, lapply(GIN, unpack.GIN)))
		}
	}

	unpack.names <- function(GIN, sofar = "") {
		# if (class(GIN) == "matrix") {
		if (is(GIN, "matrix")) {
			my.names <- c(1:ncol(GIN))
		} else my.names <- names(GIN)


		if (length(my.names) == 1) {
			names <- sofar
		} else if (length(sofar) == 1) {
			names <- my.names
		} else names <- c(outer(my.names, sofar, paste))

		# if (class(GIN) == "matrix") 
		if (is(GIN, "matrix"))
			return(names)
		else return(unpack.names(GIN[[1]], names))
	}

	model <- thresholds

	if (throld == 0.5 && !is.null(model$GIN) && is.null(item.table) && (item.type != "deltas")) {
		#print("false")
		throlds <- unpack.GIN(model$GIN)
		names <- unpack.names(model$GIN)
		colnames(throlds) <- names

		message("Using GIN table for threshold parameters")
	} else {
		RMP <- model$RMP

		if (item.type != "thresholds") {
			throlds <- make.deltas(model, item.table = item.table, interactions = interactions, step.table = step.table)

		} else {
			throlds <- make.thresholds(model, item.table = item.table, interactions = interactions, step.table = step.table, throld = throld)


		}

	}
	
	return(throlds)
}

	CCCfit <- function(itemNumber, observedResponses, personEstimates, itemParameters
			, xlim = c(-4,4), method = "Quantile", NQtiles = 10){

			curve.cols <- paste(RColorBrewer::brewer.pal(n = 8, name = "Dark2"),"40", sep = "")
			points.cols <- RColorBrewer::brewer.pal(n = 8, name = "Dark2")

			deltas <- itemParameters[itemNumber,]

			deltas <- deltas[!is.na(deltas)]

			maxCat <- length(deltas)


			probCCC <- function(theta, deltas){

			   original.length <- length(deltas) + 1

			   # delete trailing NAs in deltas vector
			   deltas <- deltas[!is.na(deltas)]

			   deltas <- c(0,deltas)

			   lN <- length(deltas)

			   M  <- matrix( rep(NA,  lN), ncol = lN)
			   CM <- matrix( rep(NA,  lN), ncol = lN)

			   M[,1]  <- 0
			   CM[,1] <- 1

			   for ( k in 2:lN ){

			       M[  , k] <- M[  , (k-1) ] + theta - deltas[k]
			       CM[ , k] <- CM[ , (k-1) ] + exp( M[  , k] )

			   }

			   output <- exp(M)/CM[,k]
			   
			   length(output) <- original.length
			   
			   output

			  }


			categoryProbs <- sapply(seq(xlim[1],xlim[2],length=100)
				, probCCC, deltas = deltas)

			plot(seq(xlim[1],xlim[2],length=100), categoryProbs[1,]
				, type = "n", axes = FALSE
				, xlab = "Proficiency"
				, ylab = "Proportion"
				, ylim = c(0,1))

			axis(2, las = 1)
			axis(1)

			lines(seq(xlim[1],xlim[2],length=100), categoryProbs[1,]
			, type = "l", lwd = 3, lty = 1, col = "grey80")

			nCats <- length(deltas) + 1
			
			for (i in 2:nCats) {

				lines(seq(xlim[1],xlim[2],length=100),
					categoryProbs[i,], lwd = 3, col = curve.cols[i-1])

			}


			if(method == "Quantile"){

				agg.data <- list()

				size.data <- list()

				for (i in 1:maxCat) {

					recodedResponses <- observedResponses == i

					cutPoints <- quantile(personEstimates,seq(0,1,length = NQtiles + 1))

					agg.data[[i]] <-aggregate(recodedResponses, by=list(cut(personEstimates,cutPoints)), 
					  FUN=mean, na.rm=TRUE)

					breakMeans <-aggregate(personEstimates, by=list(cut(personEstimates,cutPoints)), 
					  FUN=mean, na.rm=TRUE)

					agg.data[[i]][,1] <- breakMeans[,2]

					agg.data[[i]][,-1][agg.data[[i]][,-1] == 1] <- .999
					agg.data[[i]][,-1][agg.data[[i]][,-1] == 0] <- .001

					size.data[[i]] <- aggregate(is.na(recodedResponses), 
						by=list(cut(personEstimates,cutPoints)),  FUN = length)

					size.data[[i]][,1] <- breakMeans[,2]


					points(agg.data[[i]][,1],agg.data[[i]][,itemNumber + 1], 
						type = "b", pch = i, cex = .75, col = points.cols[i], lwd = 2)



				}

			}


			legend("right", horiz = FALSE, legend = paste("Cat",seq(1:maxCat))
			, col = points.cols[1:maxCat]
			, pch = 1:maxCat
			, cex = .8
			, bty = "n" )

			title(paste("Item", itemNumber) )

	}

ppPlot <-
function(thetas, thresholds = NULL, est, SE, main.title = "Person Probability Plot", cut.left = 0, cut.right = .94, cut.lab.adj = c(1,.5),...) {
	
	prob.calc <- function( x, theta.est, pr = .5 ){

        (exp( 1 * ( theta.est - x ) ) / ( 1 + exp( 1 * ( theta.est - x ) )) - pr)^2

    }
    
    cut.at <- function(x) {optimize( prob.calc, interval = c(-10,10), theta.est = est, pr = x)$minimum}
    
    cutpoints <- sapply(c(.2,.4,.5,.6,.8),cut.at)
    
    
    wrightMap(thetas, thresholds, main.title = main.title, person.points = est, person.range = c(est - SE, est + SE), cutpoints = cutpoints, cut.lab.text = c("20%","40%","50%","60%","80%"), cut.left = cut.left, cut.right = cut.right, cut.lab.adj = cut.lab.adj,...)



    
    
}

itemHist <- function(thr, yRange = NULL, axis.items = "Items", axis.logits = "Logits", 
                     show.axis.logits = "R", axis.logits.cex = 0.7, oma = c(0, 0, 0, 3), 
                     cutpoints = NULL, axis.logits.par = list(), logits.text.par = list(), 
                     cutpoints.par = list(), ...) {

    # Helper function to define breaks for histogram bins
    Nbins <- function(x) {
        itemRange <- range(x)
        return(seq(from = itemRange[1], to = itemRange[2], length.out = 25))
    }
    
    # Ensure that 'thr' is a matrix
    thr <- as.matrix(thr)
    nI <- dim(thr)[1]
    
    # Set y-axis range if not provided
    if (is.null(yRange)) {
        yRange <- c(min(thr, na.rm = TRUE), max(thr, na.rm = TRUE))
    }

    # Create histogram data for the item thresholds
    item.hist <- hist(thr, plot = FALSE, breaks = Nbins(yRange))
    bin.size <- abs(item.hist$breaks[1] - item.hist$breaks[2])
    item.hist <- data.frame(
        yleft = item.hist$mids - (bin.size / 2), 
        xbottom = item.hist$mids * 0, 
        yright = item.hist$mids + (bin.size / 2), 
        xtop = item.hist$counts
    )
    
    # Set graphical parameters
    par(oma = oma)
    par(mgp = c(1, 0.2, 0))

    # Create the base plot without axes (note swapped x and y axes for horizontal bars)
    plot(c(min(item.hist[, 2]), max(item.hist[, 4])), 
         c(min(item.hist[, 1]), max(item.hist[, 3])), 
         xlim = c(0, max(item.hist[, 4])), ylim = yRange, 
         type = "n", axes = FALSE, xlab = axis.items, ylab = "", 
         cex.lab = .8, font.lab = 3)

    # Add cutpoints if provided (using customized parameters)
    if (!is.null(cutpoints)) {
        cutpoints.default <- list(col = "black", lwd = 1, lty = 2)
        cutpoints.par <- modifyList(cutpoints.default, cutpoints.par)
        abline(v = cutpoints, col = cutpoints.par$col, lwd = cutpoints.par$lwd, lty = cutpoints.par$lty)
    }

    # Add box around the plot
    box(bty = "o")
    usr <- par("usr")
    par(mgp = c(3, 1, 0))

    # Handle axis customization for logits (using `axis.logits.par`)
    axis.default <- list(side = if (show.axis.logits == "L") 2 else 4, 
                         las = 1, cex.axis = axis.logits.cex, font.axis = 2)
    axis.logits.par <- modifyList(axis.default, axis.logits.par)
    do.call(axis, axis.logits.par)
    
    # Customize the text for the logits axis (using `logits.text.par`)
    logits.text.default <- list(text = axis.logits, side = axis.logits.par$side, 
                                line = 1.5, cex = 0.8, font = 3)
    logits.text.par <- modifyList(logits.text.default, logits.text.par)
    do.call(mtext, logits.text.par)

    # Reset graphical parameters and draw rectangles representing the histogram (swapped x and y axes)
    par(mgp = c(0, 0.2, 0))
    rect(item.hist$xbottom, item.hist$yleft, item.hist$xtop, item.hist$yright)
}

fitgraph.numeric <-
function( fitEst, fitLB, fitUB, itemLabels
	                 , mainTitle   = 'Fit Plot'
					 , pch    = 18
	                 , fitColours = c('gray70','gray60','gray50','gray40','gray0')
	                 , xlab = "Items"
	                 , cex = 1.25
	                 ,... )
{

	par(mar=c(4.1, 4.1, 3.1, 1.1))

	nI <- length(fitEst)
	item <- c(1:nI)
	#dev.new()
	plot( fitEst ~ item
		, type = "n"
		, axes = FALSE
		, ylab = "Fit"
		, xlab = ""
		, ylim = c( max( min( fitEst ) - .3, 0) , max( fitEst ) + .3)
		, xlim = c( min( item ), max( item )))
		

	title( main = mainTitle )
	
	xcorrs <-c( 0, rep( 1:( nI - 1), each = 2), nI)
	xcorrs <- xcorrs + .5
	yUBs = rep(fitUB,each = 2)
	yLBs = rep(fitLB,each = 2)
	
	
	polygon( c( min( xcorrs ), xcorrs, max(xcorrs)), c( 0, yUBs, 0 )
		   , col    = fitColours[1], border = NA) 
		   
		
	polygon( c( min( xcorrs ), xcorrs, max(xcorrs)), c( 0, yLBs, 0 )
		   , col    = "white", border = NA)
		   
		   
		
	 lines( c(head(yLBs, n = 1),yUBs) ~ c(head(xcorrs, n = 1),xcorrs)
	      , type = "l", col  = fitColours[3]
	      , lwd  = 2, lend = 2, ljoin = 2, lty  = "solid") 
    
	 lines( c(yLBs, tail(yUBs, n = 1))  ~ c(xcorrs,tail(xcorrs, n = 1))
	      , type = "l", col  = fitColours[3]
	      , lwd  = 2, lend = 2, ljoin = 2, lty  = "solid") 

	axis( 2, las = 1, tcl = -0.5
		, at = 1
		, cex.axis  = 1, font.axis = 2, col.axis  = fitColours[5])

	axis( 2, las = 1, tcl = -0.2
		, at = seq( from = 1.2, to = ( max( fitEst ) + .3 ), by = .2)
		, cex.axis  = .8, font.axis = 2, col.axis  = fitColours[5])

	axis( 2, las = 1, tcl = -0.2
		, at = seq( from = 0.8, to = ( min( fitEst ) - .3 ), by = -.2)
		, cex.axis  = .8, font.axis = 2, col.axis  = fitColours[5])

	box() 

	abline( h = as.list( seq( from = 1.0, to = ( max( fitEst ) + .3 ), by = .2))
	      , lwd = .5,col = fitColours[5])
	
	abline( h = as.list( seq( from = 0.8, to = ( max( min( fitEst ) - .3, 0) ), by = -.2))
	      , lwd = .5,col = fitColours[5])

	lines( fitEst ~ item
	     , type = "p"
	     , pch  = pch
	     , ylim = c( .5, 1.5)
	     , col  = fitColours[5]
	     , bg   = fitColours[4]
	     , xlab = 'Items'
	     , cex  = cex)
    
	text( item, fitEst, as.list( itemLabels), pos = 3, cex = .75)
}

\name{person.side}
\alias{person.side}
\alias{personHist}
\alias{personDens}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Wright Map person sides
}
\description{
Draw the person side of a Wright Map in a variety of styles. Intended to be primarily called by \code{\link{wrightMap}}, but also available for use on their own.
}
\usage{
personHist(thetas, yRange = NULL, breaks = "FD", dim.lab.cex = 0.6, dim.lab.side = 3
  , dim.lab.adj = 0.5, dim.names = NULL, dim.color = "white", person.points = NULL
  , person.range = NULL, p.point.col = "gray45", p.range.col = "gray75"
  , axis.persons = "Respondents", show.axis.persons = FALSE
  , axis.persons.par = list(), oma = c(0, 5, 0, 5), axis.logits = "Logits"
  , show.axis.logits = TRUE,...)

personDens(thetas, yRange = NULL, dim.lab.cex = 0.6, dim.lab.side = 3, dim.lab.adj = 0.5
  ,dim.names = NULL,dim.color = "black",person.points = NULL, person.range = NULL
  , p.point.col = "black", p.range.col = "gray70", oma = c(0, 5, 0, 5)
  , axis.logits = "Logits", show.axis.logits = TRUE
  , axis.persons = "Respondents",...)
}

\arguments{
  \item{thetas}{
vector or matrix of person parameters. If a matrix, persons should be the rows and dimensions the columns.
}
  \item{yRange}{
vector with 2 elements specifying the lower and upper limits of the plot's y-axis.
}
  \item{dim.lab.cex}{
An integer specifying the amount the dimension labels should be magnified relative to the default.
}
  \item{dim.lab.side}{
An integer specifying which side to plot the dimension names. Values of 1, 2, 3 (default), and 4, respectively, indicate positions below, to the left of, above, and to the right of the person distributions.
}
  \item{dim.lab.adj}{
A numerical value adjusting the position of the dimension names.
}
  \item{dim.names}{
A string or a vector of strings containing the names of each dimension. When there is only one dimension and \code{dim.names} is not specified, no dimension label is shown. For multiple dimensions, defaults to "Dim1", "Dim2", etc.
}
  \item{dim.color}{
A numerical value or vector indicating the colors to be used for representing each dimension.
}
  \item{person.points}{
A vector of individual values to highlight.
}
  \item{person.range}{
A pair of values, an even-length vector, or a matrix with two rows. Values indicate the start and endpoints of ranges to highlight. If a matrix, the first row should be lower bounds and the second row upper bounds of the ranges. If a vector, the values should alternate: (lower1, upper1, lower2, upper2, ...).
}
  \item{p.point.col}{
A string or vector of strings indicating the color to use for the highlighted points.
}
  \item{p.range.col}{
A string or vector of strings indicating the color to use for the highlighted ranges.
}
  \item{axis.persons}{
The title of the y-axis on the left side.
}
  \item{show.axis.persons}{
Logical indicating whether to show the persons axis on the left side. Default is \code{FALSE}.
}
  \item{axis.persons.par}{
A list of parameters to customize the appearance of the persons axis. This can include options such as \code{cex.axis}, \code{las}, and others as supported by the \code{\link{axis}} function.
}
  \item{oma}{
Values to use for the \code{oma} parameter (see \code{\link{par}}).
}
  \item{show.axis.logits}{
Logical indicating whether to show the logit axis.
}
  \item{axis.logits}{
The title of the y-axis on the right side.
}
  \item{\dots}{
Additional arguments passed to other methods (e.g., \code{\link{cutLines}}).
}

For \code{personHist}:
  \item{breaks}{
A parameter passed to the \code{\link{hist}} function to define the binning of the histogram.
}
}
\details{
These functions are designed as helper functions for \code{\link{wrightMap}} and \code{\link{ppPlot}} to draw the person side of a map. When called outside of those functions, they can be used to create more customized maps. Possible uses include:

\itemize{
  \item Drawing a person map on its own
  \item Comparing two person maps in a single figure
  \item Drawing a Wright Map with the item side on the left and the person side on the right
}

The \code{personHist} style, the default, draws the person distribution as a histogram. The \code{personDens} style draws a density plot.

The \code{person.points}, \code{person.range}, \code{p.point.col}, and \code{p.range.col} parameters can highlight specific values or ranges, either when called directly or via \code{\link{ppPlot}}.
}

\author{
Rebecca Freund and David Torres Irribarra
}

\seealso{
\code{\link{item.side}}
\code{\link{personData}}
\code{\link{wrightMap}}
\code{\link{ppPlot}}
}

\examples{

  # Creating a Wright Map with item side on the left

  multi.proficiency <- data.frame(
    d1 = rnorm(1000, mean =  -0.5, sd = 1),
    d2 = rnorm(1000, mean =   0.0, sd = 1),
    d3 = rnorm(1000, mean =  +0.5, sd = 1))

    
  items.loc <- sort( rnorm( 20))
  thresholds <- data.frame(
    l1 = items.loc - 0.5 ,
    l2 = items.loc - 0.25,
    l3 = items.loc + 0.25,
    l4 = items.loc + 0.5)
    
    # split.screen: Set up a split screen with the left side 80 percent of the screen
    # yRange = c(-3,4): Set the yRange to be the same for both sides
    # axis.logits.side = "L": Move the item logit axis to the left
    # oma = c(0,0,0,2): Adjust the spacing between the graphs
    # mtext("Wright Map", side = 3, font = 2, line = 1): add a title
    # screen(2): Start drawing on the second screen
    
    split.screen(figs = matrix(c(0,.8,0,1,.8,1,0,1),ncol = 4, byrow = TRUE)) 
    itemModern(thresholds, yRange = c(-3,4), show.axis.logits = "L", oma = c(0,0,0,2))
    mtext("Wright Map", side = 3, font = 2, line = 1)
    screen(2)
    personHist(multi.proficiency, axis.persons = "", yRange = c(-3,4)
      , axis.logits = "Persons", show.axis.logits = FALSE)
    
    ## Creating a multidimensional Wright Map with each dimension separate

    ## Mock results

    d1 = rnorm(1000, mean =  -0.5, sd = 1)
    d2 = rnorm(1000, mean =   0.0, sd = 1)

    dim1.diff <- rnorm(5)
    dim2.diff <- rnorm(5)
  
    split.screen(figs = matrix(c(0,.1,0,1, .12,.6,0,1, .5,.6,0,1, .5,1,0,1)
      ,ncol = 4,byrow = TRUE))
                  
    personDens(d1, yRange = c(-3,3), show.axis.logits = FALSE, axis.logits = "")
    screen(2)
    itemModern(dim1.diff, yRange = c(-3,3), show.axis.logits = FALSE)
    mtext("Wright Map", side = 3, font = 2, line = 1)
    screen(3)
    personDens(d2, yRange = c(-3,3), show.axis.logits = FALSE
      , axis.logits = "", axis.persons = "", dim.names = "Dim2")
    screen(4)
    itemModern(dim2.diff, yRange = c(-3,3), show.axis.logits = FALSE
      , label.items = paste("Item", 6:10))

}

\name{extract.deltas}
\alias{extract.deltas}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Extract Master's Delta parameters from a TAM model.
}
\description{
This function takes as its input a TAM object. It adds reads the TAM item parameters and organizes them into a matrix that can be used as input in the \code{\link{CCCfit}} function.
}
\usage{
extract.deltas(tamObject)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{tamObject}{
  TAM object containing the results of a a Rasch model or Partial Credit model.
}
}
\details{
This function organizes the item parameter results into a matrix where each row is contains the parameters associated with an item and each columns is contains the parameters associated with a specific step (score 0 vs score 1, score 1 vs score 2, etc.). The resulting matrix will have as many rows as items and as many columns as the maximum number of steps among the items.
}
\value{
A matrix in which each row is an item and each column is a step
}
\references{
Masters, G. N. (1982). A Rasch model for partial credit scoring. \emph{Psychometrika}, 47(2), 149-174. 
}
\author{
David Torres Irribarra
}
%\note{
%%  ~~further notes~~
%}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
 \code{\link{CCCfit}}
 \code{\link{make.thresholds}}
}
\examples{
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

## The function is currently defined as
function (tamObject) 
{
    delta.long <- tamObject$xsi
    n.deltas <- apply(tamObject$B, 1, max)
    delta.mat <- matrix(NA, nrow = length(n.deltas), ncol = max(n.deltas))
    matCoords.row <- rep(1:length(n.deltas), n.deltas)
    matCoords.col <- c()
    for (i in 1:length(n.deltas)) {
        for (j in 1:n.deltas[i]) {
            matCoords.col <- c(matCoords.col, j)
        }
    }
    delta.long$matCoords.row <- matCoords.row
    delta.long$matCoords.col <- matCoords.col
    for (k in 1:nrow(delta.long)) {
        delta.mat[delta.long$matCoords.row[k], delta.long$matCoords.col[k]] <- delta.long$xsi[k]
    }
    delta.mat
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory (show via RShowDoc("KEYWORDS")):
% \keyword{ ~kwd1 }
% \keyword{ ~kwd2 }
% Use only one keyword per line.
% For non-standard keywords, use \concept instead of \keyword:
% \concept{ ~cpt1 }
% \concept{ ~cpt2 }
% Use only one concept per line.

\name{CCCfit}
\alias{CCCfit}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Empirical category characteristic curve plot for the Partial Credit Model
}
\description{
The \code{CCCfit} function is intended for contrasting a Rasch model's expected category characteristic curve against the empirical data from observed responses. The \code{CCCfit} function displays the expected probability asociated with all response categories and plots the observed response proportions for all non-zero response categories.
}
\usage{
CCCfit(itemNumber, observedResponses, personEstimates, 
    itemParameters, xlim = c(-4, 4), method = "Quantile", NQtiles = 10)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{itemNumber}{
The position of the item in the test. This position is used to select the column of observed responses and the item difficulty among the item parameters.
}
  \item{observedResponses}{
Data frame or matrix with observed responses. The data frame or matrix should be of size  N * I, where N is the number of respondents and I is the number of items in the model.
}
  \item{personEstimates}{
A vector of length N containing the model based person estimates or predictions.
}
  \item{itemParameters}{
A data frame or matrix with I rows (one for each item) and M columns, where M is equal to the maximum number of item scores minus 1. This matrix contains the model based estimates for the step parameters (deltas), where column 1 contains the parameter associated with the step between category 0 versus category 1, column 2 the step parameters of category 1 versus category 2, and so on.
}
  \item{xlim}{
Vector with two values indicating the minimum and maximum values to be used when plotting the item characteristic curve.
}
  \item{method}{
Selects the \code{Quantile} method to group the respondents (see `Details').
}
  \item{NQtiles}{
This value controls how many grouping will be used: 4 groups cases groups respondents by quartiles, 5 by quintiles, 10 by deciles, etc.
}
}
\details{
The function uses the step difficulty parameters to generate the model based curve. The observed responses are then grouped using the \code{Quantile} method in order to contrast the model predicted response probability with the observed proportion (this is the only method implemented so far). By default the function uses deciles to generate the respondent groups.
}
% \value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
%% ...
% }
% \references{
%% ~put references to the literature/web site here ~
% }
\author{
David Torres Irribarra
}
% \note{
%%  ~~further notes~~
% }

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
 \code{\link{ICCfit}}
}
\examples{
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

## The function is currently defined as
function (itemNumber, observedResponses, personEstimates, itemParameters, 
    xlim = c(-4, 4), method = "Quantile", NQtiles = 10) 
{
    curve.cols <- paste(RColorBrewer::brewer.pal(n = 8, name = "Dark2"), 
        "40", sep = "")
    points.cols <- RColorBrewer::brewer.pal(n = 8, name = "Dark2")
    deltas <- itemParameters[itemNumber, ]
    deltas <- deltas[!is.na(deltas)]
    maxCat <- length(deltas)
    probCCC <- function(theta, deltas) {
        original.length <- length(deltas) + 1
        deltas <- deltas[!is.na(deltas)]
        deltas <- c(0, deltas)
        lN <- length(deltas)
        M <- matrix(rep(NA, lN), ncol = lN)
        CM <- matrix(rep(NA, lN), ncol = lN)
        M[, 1] <- 0
        CM[, 1] <- 1
        for (k in 2:lN) {
            M[, k] <- M[, (k - 1)] + theta - deltas[k]
            CM[, k] <- CM[, (k - 1)] + exp(M[, k])
        }
        output <- exp(M)/CM[, k]
        length(output) <- original.length
        output
    }
    categoryProbs <- sapply(seq(xlim[1], xlim[2], length = 100), 
        probCCC, deltas = deltas)
    plot(seq(xlim[1], xlim[2], length = 100), categoryProbs[1, 
        ], type = "n", axes = FALSE, xlab = "Proficiency", ylab = "Proportion", 
        ylim = c(0, 1))
    axis(2, las = 1)
    axis(1)
    lines(seq(xlim[1], xlim[2], length = 100), categoryProbs[1, 
        ], type = "l", lwd = 3, lty = 1, col = "grey80")
    nCats <- length(deltas) + 1
    for (i in 2:nCats) {
        lines(seq(xlim[1], xlim[2], length = 100), categoryProbs[i, 
            ], lwd = 3, col = curve.cols[i - 1])
    }
    if (method == "Quantile") {
        agg.data <- list()
        size.data <- list()
        for (i in 1:maxCat) {
            recodedResponses <- observedResponses == i
            cutPoints <- quantile(personEstimates, seq(0, 1, 
                length = NQtiles + 1))
            agg.data[[i]] <- aggregate(recodedResponses, by = list(cut(personEstimates, 
                cutPoints)), FUN = mean, na.rm = TRUE)
            breakMeans <- aggregate(personEstimates, by = list(cut(personEstimates, 
                cutPoints)), FUN = mean, na.rm = TRUE)
            agg.data[[i]][, 1] <- breakMeans[, 2]
            agg.data[[i]][, -1][agg.data[[i]][, -1] == 1] <- 0.999
            agg.data[[i]][, -1][agg.data[[i]][, -1] == 0] <- 0.001
            size.data[[i]] <- aggregate(is.na(recodedResponses), 
                by = list(cut(personEstimates, cutPoints)), FUN = length)
            size.data[[i]][, 1] <- breakMeans[, 2]
            points(agg.data[[i]][, 1], agg.data[[i]][, itemNumber + 
                1], type = "b", pch = i, cex = 0.75, col = points.cols[i], 
                lwd = 2)
        }
    }
    legend("right", horiz = FALSE, legend = paste("Cat", seq(1:maxCat)), 
        col = points.cols[1:maxCat], pch = 1:maxCat, cex = 0.8, 
        bty = "n")
    title(paste("Item", itemNumber))
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory (show via RShowDoc("KEYWORDS")):
% \keyword{ ~kwd1 }
% \keyword{ ~kwd2 }
% Use only one keyword per line.
% For non-standard keywords, use \concept instead of \keyword:
% \concept{ ~cpt1 }
% \concept{ ~cpt2 }
% Use only one concept per line.

\name{sim.PCM}
\alias{sim.PCM}
\title{Simulate Item Responses for Partial Credit and Rasch Models with Varying Levels}
\description{
Simulate polytomous item responses based on item difficulty thresholds (\code{delta}) and person abilities (\code{theta}) for the Partial Credit Model (PCM) and the Rasch Model as a special case. The function allows items to have varying numbers of levels, making it useful for generating data in contexts such as item response theory (IRT) models for polytomous items (e.g., Likert scales).
}
\usage{
sim.PCM(pN, iN, lN, itemLevels = NULL, delta = NULL, delta.l = NULL, theta = NULL)
}
\arguments{
  \item{pN}{\code{integer}. The number of people (respondents) to simulate.}
  \item{iN}{\code{integer}. The number of items in the test or survey.}
  \item{lN}{\code{integer}. The default number of levels (categories) for each polytomous item. Must be greater than or equal to 2. This is used if \code{itemLevels} is not provided.}
  \item{itemLevels}{\code{integer vector}. An optional vector specifying the number of levels for each item. If provided, the length must equal \code{iN}. If not provided, all items are assumed to have \code{lN} levels.}
  \item{delta}{\code{matrix}. An optional matrix of item thresholds with dimensions \code{iN} by the maximum number of levels in \code{itemLevels}. If not provided, the function will generate thresholds internally. The first column must contain zeros or the function will automatically prepend a column of zeros. If provided as a vector, it will be converted into a single-column matrix.}
  \item{delta.l}{\code{numeric vector}. An optional vector of common level thresholds (with length \code{lN - 1}). This vector represents the difficulty of each level. If not provided, the function will generate it.}
  \item{theta}{\code{numeric vector}. An optional vector of person abilities. If not provided, abilities will be drawn from a standard normal distribution (mean = 0, sd = 1).}
}
\details{
This function generates polytomous item responses using a logistic IRT model. It first creates or uses given person abilities (\code{theta}) and item thresholds (\code{delta}). Responses are simulated by computing the probability of a person responding in each category of an item based on their ability and the item's threshold. The function allows for items to have different numbers of response categories through the \code{itemLevels} argument.
}
\value{
A list with the following components:
  \item{pN}{The number of people (respondents).}
  \item{iN}{The number of items.}
  \item{lN}{The default number of levels (categories) for the polytomous items.}
  \item{itemLevels}{A vector specifying the number of levels for each item.}
  \item{M}{A list of \code{iN} matrices containing logits (differences between person ability and item threshold) for each person and item.}
  \item{CM}{A list of \code{iN} matrices containing cumulative probabilities for each person and item.}
  \item{U}{A \code{pN} by \code{iN} matrix of uniform random values used to generate the responses.}
  \item{theta}{A numeric vector of person abilities.}
  \item{delta.l}{(Optional) A vector of common level thresholds if it was generated internally.}
  \item{delta.il}{(Optional) A matrix of item-specific deviations for thresholds if \code{delta.l} was generated internally.}
  \item{delta}{A matrix of item thresholds.}
  \item{resp}{A \code{pN} by \code{iN} matrix of simulated responses. Each entry corresponds to the level chosen by the person for the respective item.}
}
\examples{
# Simulate 100 respondents, 5 items, and 3 levels (e.g., Likert scale with 3 options)
simulated_data <- sim.PCM(pN = 100, iN = 5, lN = 3)

# Simulate with custom item thresholds
custom_delta <- matrix(c(-0.5, -1, -2, 1, 0.5, 1), nrow = 3)
simulated_data_custom <- sim.PCM(pN = 50, iN = 3, lN = 3, delta = custom_delta)

# Simulate with custom person abilities
custom_theta <- rnorm(100, mean = 0, sd = 1.5)
simulated_data_theta <- sim.PCM(pN = 100, iN = 5, lN = 3, theta = custom_theta)

# Rasch model simulation (dichotomous items)
# 50 persons with abilities ranging from -3 to 3
rasch_theta <- seq(-3, 3, length.out = 50)
rasch_delta <- matrix(c(0,1.5,0,-1,0,0.5,0,-0.5,0,1,0,-1.5,0,2,0,-2,0,0.8,0,-0.8)
                      , ncol = 2, byrow = TRUE)
simulated_rasch <- sim.PCM(pN = 50, iN = 10, lN = 2, delta = rasch_delta, theta = rasch_theta)

# Simulation with items having different numbers of levels
# 4 items with 5 levels, 3 items with dichotomous responses, and 3 items with 3 levels
# Simulate with a total of 10 items and varying levels
simulated_mixed_levels <- sim.PCM(pN = 50, iN = 10, lN = 5, 
                                  itemLevels = c(5, 5, 5, 5, 2, 2, 2, 3, 3, 3))
}
\seealso{
\code{\link{runif}}, \code{\link{rnorm}}
}
\author{
David Torres Irribarra
}

\name{item.person.data}
\alias{item.person.data}

\alias{itemData}
\alias{itemData.default}
\alias{itemData.CQmodel}
\alias{itemData.character}

\alias{personData}
\alias{personData.default}
\alias{personData.CQmodel}
\alias{personData.character}

%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Processing CQmodel objects for plotting
}
\description{
The \code{itemData} and \code{personData} functions take CQmodel objects (or ConQuest output files) as inputs and return a vector or matrix. They were originally developed for use by \code{\link{wrightMap}}, but are separated out here to allow the outputs to be sent to other plotting functions.
}
\usage{
itemData(thresholds, \dots)
\method{itemData}{default}(thresholds, item.type = "deltas",\dots)
\method{itemData}{character}(thresholds, p.type = NULL, equation = NULL, \dots)
\method{itemData}{CQmodel}(thresholds, item.table = NULL, interactions = NULL, 
step.table = NULL, item.type = "default", throld = 0.5, \dots)

personData(thetas,\dots)
\method{personData}{default}(thetas,\dots)
\method{personData}{character}(thetas, p.type = NULL,\dots)
\method{personData}{CQmodel}(thetas,\dots)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
	
itemData arguments:
  \item{thresholds}{
  	Usually, a CQmodel object or the name of a ConQuest show file. Will also accept a matrix, but this is only really for use within other functions. In general \code{\link{make.thresholds}} should be used instead.
  	}
  	
  	\item{item.type}{
Indicates whether to use \code{thresholds} or \code{deltas}.
}

  \item{equation}{
  	 string giving the model equation, if the Summary of Estimation table was not included in the show file.
  	 }

\item{item.table}{
  Name of RMP table to use for the main effect of the item parameters.
}
  \item{interactions}{
  Name of RMP interaction table to use in addition to \code{item.table}.
}
  \item{step.table}{
  Name of RMP table to use in addition to \code{item.table}.
}
  
  \item{throld}{
The probability level to be used for calculating thresholds.
}
  \item{\dots}{
Additional parameters to pass to \code{\link{make.thresholds}}.
}

personData arguments:

\item{thetas}{a CQModel object or the name of the Conquest person parameters file (EAPs, MLEs, etc.)}
 \item{p.type}{ Type of person parameter estimate (EAP, MLE or WLE). }

}

\details{
	The itemData and personData functions are usually called by \code{\link{wrightMap}}. They can also be called directly.
	
For the itemData function, note that the \code{item.table}, \code{interactions}, and \code{step.table} parameters must be the exact name of specific RMP tables. You cannot specify an interactions table or a step table without also specifying an item table (although JUST an item table is fine). If your model equation is more complicated, you will have to either use a GIN table or specify in the function call which tables to use for what. A model of the form item + item * step + booklet, for example, will not run unless there is a GIN table or you have defined at least the item.table.
}



\value{
The itemData functions return a vector of item parameters, or a matrix in which the rows are items and the columns are steps. The personData functions return a vector of person parameters, or a matrix in which the rows are persons and the columns are dimensions.
}

\author{
Rebecca Freund and David Torres Irribarra }

\seealso{
\code{\link{item.side}}
\code{\link{person.side}}
\code{\link{make.thresholds}}
\code{\link{make.deltas}}
\code{\link{wrightMap}}
}
\examples{
	
#As a call from wrightMap:

fpath <- system.file("extdata", package="WrightMap")

model1 <- CQmodel(file.path(fpath,"ex2a.eap"), file.path(fpath,"ex2a.shw"))
# Making thresholds if there are no GIN tables (partial credit model)
	wrightMap(model1, type = "thresholds") 
	
#Complex model:

model2 <- CQmodel(file.path(fpath,"ex4a.mle"), file.path(fpath,"ex4a.shw")) 
wrightMap(model2, item.table = "rater")
	wrightMap(model2, item.table = "rater", interactions = "rater*topic", 
  step.table = "topic")


# Plotting item results
	
	fpath <- system.file("extdata", package="WrightMap")
	model3 <- CQmodel(file.path(fpath,"ex2a.eap"), file.path(fpath,"ex2a.shw"))
	m3.item <- itemData(model3)
	
	dev.new(width=10, height=10)
	
	#control of oma allows us to give more space to longer item names
	itemModern(m3.item, label.items.srt= 90, oma = c(2,0,0,2)) 
	itemClassic(m3.item)
	itemHist(m3.item)
	
	m3.person <- personData(model3)
	personHist(m3.person)
	personDens(m3.person)
  }

\name{ICCfit}
\alias{ICCfit}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Empirical item characteristic curve plot for the Rasch Model~
}
\description{
The \code{ICCfit} function is intended for contrasting a Rasch model's expected item characteristic curve against the empirical data from dichotomous responses. The \code{ICCfit} function displays a confidence interval for the model based curve and plots the confidence interval for the empirical proportions.
}
\usage{
ICCfit(itemNumber, observedResponses, personEstimates, 
    itemParameters, xlim = c(-4, 4), method = "Quantile", NQtiles = 10)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{itemNumber}{
The position of the item in the test. This position is used to select the column of observed responses and the item difficulty among the item parameters.
}
  \item{observedResponses}{
Data frame or matrix with observed responses. The data frame or matrix should be of size  N * I, where N is the number of respondents and I is the number of items in the model.
}
  \item{personEstimates}{
A vector of length N containing the model based person estimates or predictions.
}
  \item{itemParameters}{
A data frame or matrix of dimensions I * 2 containing the model based item difficulty estimates in the firs column and the parameter standard error in the second column.
}
  \item{xlim}{
Vector with two values indicating the minimum and maximum values to be used when plotting the item characteristic curve.
}
  \item{method}{
Selects the method used to group the respondents: \code{Quantile} (default), \code{ByPersonEstimate}, and \code{Histogram} (see `Details').
}
  \item{NQtiles}{
When using the \code{Quantile} method this value controls how many grouping will be used: 4 groups cases groups respondents by quartiles, 5 by quintiles, 10 by deciles, etc.
}
}
\details{
The function uses the item difficulty parameter to generate the model based curve and the item difficulty parameter standard error to plot a confidence interval around the curve. The observed responses are then grouped using the selected method in order to contrast the model predicted response probability with the observed proportion. By default the function uses deciles to generate the respondent groups. The function allows the method \code{ByPersonEstimate} in order to make a different group for each observed person estimate (potentially useful when analyzing test data with large numbers with no missing data), and the \code{Histogram} method, which uses the Freedman-Diaconis algorithm to select the width of the bands used for grouping.
}
% \value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
%% ...
% }
% \references{
%% ~put references to the literature/web site here ~
% }
\author{
David Torres Irribarra
}
% \note{
%%  ~~further notes~~
% }

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
 \code{\link{CCCfit}}
}
\examples{

# Simulate 1000 persons and 5 items with 2 levels (Rasch model)
set.seed(123)
simulated_data <- sim.PCM(pN = 1000, iN = 5, lN = 2)

# Extract simulated item responses and abilities
observed_responses <- simulated_data$resp - 1
person_abilities <- simulated_data$theta
item_params <- cbind(simulated_data$delta[,2],rep(0.08),5) 
# Defining a 0.08 of error for the item parameters, 
# this usually would be estimated.

# Plot the ICC for the first item using the Quantile method
ICCfit(itemNumber = 1, 
       observedResponses = observed_responses, 
       personEstimates = person_abilities, 
       itemParameters = item_params, 
       method = "Quantile", 
       NQtiles = 10)




}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory (show via RShowDoc("KEYWORDS")):
% \keyword{ ~kwd1 }
% \keyword{ ~kwd2 }
% Use only one keyword per line.
% For non-standard keywords, use \concept instead of \keyword:
% \concept{ ~cpt1 }
% \concept{ ~cpt2 }
% Use only one concept per line.

\name{item.side}
\alias{item.side}
\alias{itemClassic}
\alias{itemModern}
\alias{itemHist}

\title{Wright Map Item Sides}
\description{Draw the item side of a Wright Map in a variety of styles. Intended to be primarily called by \code{\link{wrightMap}}, but also available for use on their own.}
\usage{
itemModern(thr, yRange = NULL, axis.items = "Items", show.thr.sym = TRUE
, thr.sym.cex = 0.8, thr.sym.lwd = 1, thr.sym.pch = 23
, thr.sym.col.fg = rgb(0, 0, 0, 0.3), thr.sym.col.bg = rgb(0, 0, 0, 0.3)
, show.thr.lab = TRUE, thr.lab.pos = c(2, 4), thr.lab.text = NULL
, thr.lab.type = NULL, thr.lab.col = "black", thr.lab.cex = 0.5
, thr.lab.font = 2, label.items.rows = 1
, label.items.srt = 0, label.items = NULL, label.items.cex = 0.6
, label.items.ticks = TRUE, axis.logits = "Logits", show.axis.logits = "R"
, axis.logits.cex = 0.7, oma = c(0, 0, 0, 3), cutpoints = NULL
, vertLines = FALSE, vertLines.par = list(), cutpoints.par = list()
, thr.sym.par = list(), thr.lab.par = list(), label.items.par = list()
, axis.logits.par = list(), logits.text.par = list(), ...)

itemClassic(thr, yRange = NULL, axis.items = "Items", axis.logits = "Logits"
, show.axis.logits = "R", axis.logits.cex = 0.7, oma = c(0, 0, 0, 3)
, cutpoints = NULL, cutpoints.par = list(), label.items = NULL, label.steps = NULL
, label.steps.type = NULL, label.sep = ".", thr.lab.sep = " | "
, thr.lab.par = list(), axis.logits.par = list()
, logits.text.par = list(), pad.char = "_", font.family = "mono", ...)

itemHist(thr, yRange = NULL, axis.items = "Items", axis.logits = "Logits"
, show.axis.logits = "R", axis.logits.cex = 0.7, oma = c(0, 0, 0, 3)
, cutpoints = NULL, axis.logits.par = list(), logits.text.par = list()
, cutpoints.par = list(), ...)
}
\arguments{
General arguments:
  \item{thr}{A vector or matrix of threshold parameters. If a matrix, items should be in rows and steps in columns.}
  \item{yRange}{A vector with 2 elements specifying the lower and upper limits of the plot's y-axis.}
  \item{label.items}{A vector of strings representing the item labels used in itemModern and itemClassic}
  \item{axis.items}{The title of the x-axis.}
  \item{axis.logits}{The title of the y-axis.}
  \item{axis.logits.cex}{The size of the logit values on the y-axis.}
  \item{show.axis.logits}{If set to "R" or "L", draws a logit axis on the right or left. Will also draw an axis on the right if the value is \code{TRUE}. If any other value, the axis is not drawn.}
  \item{oma}{Values to use for the \code{oma} parameter (see \code{\link{par}}).}
  \item{cutpoints}{Values at which to draw horizontal lines (see \code{\link{cutLines}}).}
  \item{label.items.par}{A list of parameters to further customize item labels.}
  \item{axis.logits.par}{A list of parameters for customizing the logit axis.}
  \item{logits.text.par}{A list of parameters for customizing the logit axis text.}
  \item{\dots}{Additional arguments passed to \code{\link{cutLines}}.}

Specific to \code{itemModern}:
  \item{show.thr.sym}{Logical. If \code{TRUE} (default), the plot will show symbols for the item thresholds.}
  \item{thr.sym.cex}{An integer, vector, or matrix of numerical values indicating the magnification of the threshold symbols.}
  \item{thr.sym.lwd}{An integer, vector, or matrix of positive numbers specifying the width of the lines used in the threshold symbols.}
  \item{thr.sym.pch}{An integer, vector, or matrix specifying a symbol or single character used to represent item thresholds.}
  \item{thr.sym.col.fg}{An integer, vector, or matrix of numerical values indicating the foreground color for the threshold symbols.}
  \item{thr.sym.col.bg}{An integer, vector, or matrix of numerical values indicating the background color for the threshold symbols.}
  \item{show.thr.lab}{Logical. If \code{TRUE} (default), the plot will show labels for the item thresholds.}
  \item{thr.lab.pos}{An integer, vector, or matrix indicating the position for displaying the threshold labels. Values 1, 2, 3, and 4 indicate below, left, above, and right, respectively.}
  \item{thr.lab.text}{A matrix containing the text labels for the item thresholds, where each row represents an item, and each column represents a level. If not provided, defaults to the column names of \code{thr} if they exist, or simple numeric labels (1, 2, 3, etc.) otherwise. Use \code{thr.lab.type = "transition"} for category transition labels when no column names exist.}
  \item{thr.lab.type}{Optional string to control default threshold label format when \code{thr.lab.text} is not provided and the threshold matrix has no column names. Set to \code{"transition"} to use category transition labels (0/1, 1/2, 2/3, etc.). Default is \code{NULL} which uses simple numeric labels (1, 2, 3, etc.). Note: Column names take precedence over \code{thr.lab.type}.}
  \item{thr.lab.col}{A matrix specifying the color for each threshold label.}
  \item{thr.lab.cex}{A numerical value indicating the magnification factor for the threshold labels.}
  \item{thr.lab.font}{An integer or matrix specifying the font type for the threshold labels. 1 = plain, 2 = bold, 3 = italic, 4 = bold italic.}
  \item{label.items.rows}{An integer specifying the number of rows used to display the item labels (default: 1). Useful when item labels overlap.}
  \item{label.items.srt}{Angle of rotation for item labels. Only applicable if \code{label.items.rows} is set to 1.}
  \item{label.items.cex}{A numerical value specifying the magnification factor for the item labels.}
  \item{label.items.ticks}{Logical. If \code{TRUE} (default), ticks are drawn on the x-axis for the item side.}
  \item{vertLines}{Logical. If \code{TRUE}, vertical lines are drawn to mark all symbols associated with an item.}
  \item{vertLines.par}{A list of parameters (e.g., \code{col}, \code{lwd}, \code{lty}) to control the appearance of the vertical lines.}
  \item{cutpoints.par}{A list of parameters (e.g., \code{col}, \code{lwd}, \code{lty}) to customize the cutpoint lines.}
  \item{thr.sym.par}{A list of parameters to further customize threshold symbols.}
  \item{thr.lab.par}{A list of parameters to further customize threshold labels.}
  

Specific to \code{itemClassic}:

  \item{label.steps}{A vector specifying the labels for the threshold steps. If not provided, defaults to simple numeric labels (1, 2, 3, etc.). Set to \code{TRUE} to use column names from \code{thr} if available. Use \code{label.steps.type = "transition"} for category transition labels.}
  \item{label.steps.type}{Optional string to control default step label format when \code{label.steps} is not provided. Set to \code{"transition"} to use category transition labels (0/1, 1/2, 2/3, etc.). Default is \code{NULL} which uses simple numeric labels (1, 2, 3, etc.).}
  \item{label.sep}{A string indicating the separator used between item labels and step labels.}
  \item{thr.lab.sep}{A string indicating the separator used between threshold labels for different items.}
  \item{pad.char}{A character used to pad item labels to a fixed width.}
  \item{font.family}{A string specifying the font family for the item labels (default: \code{mono}).}

}
\details{
These functions are designed as helper functions for \code{\link{wrightMap}} to draw the item side of a map. When called outside of that function, they can be used to create more customized maps. Possible uses include:

\itemize{
  \item Draw an item map on its own.
  \item Compare two item maps in a single figure.
  \item Draw a Wright Map with the item side on the left and the person side on the right.
}
}

\author{Rebecca Freund and David Torres Irribarra}
\note{
When combining with a \code{\link{person.side}} function, note that those functions use \code{\link{split.screen}}, which are incompatible with \code{\link{layout}} and some other plotting functions. Ensure that all graphs on a single plot have their \code{yRange} explicitly specified to maintain comparable values across plots.
}

\seealso{
\code{\link{wrightMap}}, \code{\link{person.side}}, \code{\link{itemData}}
}
\examples{

#As a call from wrightMap:

## Mock results
uni.proficiency <- rnorm(1000, mean =  -0.5, sd = 1)

items.loc <- sort(rnorm(20))
thresholds <- data.frame(
  l1 = items.loc - 0.5,
  l2 = items.loc - 0.25,
  l3 = items.loc + 0.25,
  l4 = items.loc + 0.5
)

## Setting up labels, colors, and symbols
thresholds.labels <- data.frame(
  l1 = paste('Lev', rep(1, 20), sep = ''),
  l2 = paste('Lev', rep(2, 20), sep = ''),
  l3 = paste('Lev', rep(3, 20), sep = ''),
  l4 = paste('Lev', rep(4, 20), sep = '')
)

thresholds.colors <- data.frame(
  l1 = rep('green', 20),
  l2 = rep('red', 20),
  l3 = rep('yellow', 20),
  l4 = rep('blue', 20)
)

thresholds.symbols <- data.frame(
  l1 = rep(15, 20),
  l2 = rep(16, 20),
  l3 = rep(17, 20),
  l4 = rep(18, 20)
)

wrightMap(uni.proficiency, thresholds,
  thr.lab.text = thresholds.labels,
  thr.lab.col = as.vector(as.matrix(thresholds.colors)),
  thr.sym.pch = thresholds.symbols
)

# Direct call:

## Plotting results of a unidimensional Rating Scale Model
## Default labels are 1, 2, 3, etc.
items.loc <- sort(rnorm(20))
thresholds <- cbind(
  items.loc - 0.5,
  items.loc - 0.25,
  items.loc + 0.25,
  items.loc + 0.5
)
rownames(thresholds) <- paste0("Item", 1:20)

itemModern(thresholds)  # Default: 1, 2, 3, 4
itemModern(thresholds, thr.lab.type = "transition")  # Transition: 0/1, 1/2, 2/3, 3/4

itemClassic(thresholds)  # Default: 1, 2, 3, 4
itemClassic(thresholds, label.steps.type = "transition")  # Transition: 0/1, 1/2, 2/3, 3/4

itemHist(thresholds)
}

\name{make.thresholds}
\alias{make.thresholds}
\alias{make.thresholds.default}
\alias{make.thresholds.CQmodel}
\alias{make.thresholds.character}
\alias{make.thresholds.matrix}
\title{
Calculate Thurstonian thresholds.
}
\description{
This function accepts a matrix of delta parameters and converts them to thresholds (using a threshold of .5). It can also take as input a CQmodel object or a filename of a ConQuest show file.}
\usage{
make.thresholds(item.params, \dots)
\method{make.thresholds}{character}(item.params, design.matrix = "normal",\dots)
\method{make.thresholds}{CQmodel}(item.params,item.table = NULL, interactions = NULL
,step.table = NULL, design.matrix = "normal", throld = 0.5, alpha = 1,\dots)
\method{make.thresholds}{default}(item.params, design.matrix = "normal"
, make.from = "deltas", theta.interval = c(-10, 10), throld = 0.5, alpha = 1
, c.params = 0,\dots)
\method{make.thresholds}{matrix}(item.params, design.matrix = "normal"
, make.from = "deltas", theta.interval = c(-10, 10), throld = 0.5
, alpha = 1, c.params = 0,\dots)
}

\arguments{
  \item{item.params}{The item parameters. Can either be a matrix, a CQmodel object, or a path to a ConQuest show file}
  \item{design.matrix}{Can be "normal" or "ConQuest". Note that for a CQmodel object or ConQuest file, should be normal, NOT ConQuest.}
  \item{make.from}{Specifies whether the item.params matrix contains threshold or delta parameters.}
\item{item.table}{If item.params is a CQmodel object or a path to a ConQuest show file, item.table is the name of the items table. Commonly "item" but can be any string representing the name of a table in the ConQuest show file. This identifies what variable will form the rows of the thresholds matrix. If not specified, will be the first variable mentioned in the model equation.}
\item{interactions}{If item.params is a CQmodel object or a path to a ConQuest show file, item.table is the name of the table with the interactions (if present). Commonly "item*step" but can be any string containing "*" that is the name of a table in the ConQuest show file. Should be the product of the item.table variable and the step.table variable (if present). If not specified, will be the product term of the model equation.}
\item{step.table}{If item.params is a CQmodel object or a path to a ConQuest show file, step.table is the name of the steps table (if present). Commonly "step" but can be any string representing the name of a table in the ConQuest show file. This identifies what variable will form the columns of the thresholds matrix. If not specified, will be the second variable mentioned in the model equation.}
\item{theta.interval}{If item.params is a matrix, theta.interval specifies over what interval to search for the parameters.}
\item{throld}{The probability level to use for calculating the thresholds.}
\item{alpha}{A vector or single value for the slope parameter or parameters.}
\item{c.params}{A vector or single value for the guessing parameter or parameters.}

  \item{\dots}{
Additional parameters.
}
}

\value{
A matrix of threshold parameters.
}
\author{
Daniel Coulter Furr, Rebecca Freund, & David Torres Irribarra
}

\seealso{
 \code{\link{make.deltas}}
 \code{\link{itemData}}
 \code{\link{CQmodel}}
 \code{\link{wrightMap}}
}
\examples{
fpath <- system.file("extdata", package="WrightMap")

# Partial credit model
model1 <- CQmodel(file.path(fpath,"ex2a.eap"), file.path(fpath,"ex2a.shw")) 
deltas <- make.deltas(model1)
make.thresholds(deltas)
make.thresholds(model1)
}

\name{fitgraph}
\alias{fitgraph}
\alias{fitgraph.default}
\alias{fitgraph.CQmodel}
\alias{fitgraph.character}
\alias{fitgraph.numeric}
\title{
Item Fit Graphs
}
\description{
	This function creates a graphical summary of the item fit information.
}
\usage{

\method{fitgraph}{default}(fitEst, fitLB, fitUB, itemLabels, mainTitle = "Fit Plot", 
pch = 18, fitColours = c("gray70", "gray60", "gray50", "gray40", "gray0"), 
xlab = "Items", cex = 1.25, ...)
\method{fitgraph}{numeric}(fitEst, fitLB, fitUB, itemLabels, mainTitle = "Fit Plot", 
pch = 18, fitColours = c("gray70", "gray60", "gray50", "gray40", "gray0"), 
xlab = "Items", cex = 1.25, ...)
\method{fitgraph}{CQmodel}(fitEst, table = NULL, fit.type = "W", itemLabels = NULL, ...)
\method{fitgraph}{character}(fitEst, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
	
fitgraph arguments: 	
	
  \item{fitEst}{
	vector of item fit estimates. Could also be a CQmodel object or name of a ConQuest show file.
}
  \item{fitLB}{
	vector of lower bounds for critical intervals for each item.
}
  \item{fitUB}{
	vector of upper bounds for critical intervals for each item.}
  \item{itemLabels}{
	vector of item labels.
}
  \item{mainTitle}{
	string containing the title of the plot.
}
  \item{pch}{
	number or vector indicating the type of symbols to be used for each item.
}
  \item{fitColours}{
	Color that will be used to shade the critical interval area.
}
  \item{xlab}{
	Label of the x-axis. The default is `items`.
}
  \item{cex}{
	Size of the x-axis label.
}

  \item{\dots}{
	Additional parameters.
}

Argument to use when passing a CQmodel object:

  \item{table}{
	Name of the RMP table that for which the fit will be plotted. By default \code{fitgraph} will plot the first RMP table of the CQmodel object, this argument overrides this default.
}

  \item{fit.type}{
	Type of fit estimate that will be used, it can be \code{W} for Weighted Fit (i.e. Infit, the default), or \code{U} for Unweighted Fit (i.e. Outfit). Called \code{type} in previous versions; use of that parameter is deprecated to avoid collision with the \code{type} parameter in the \code{link{plot}} function.
}

}

\references{
	Wilson, M. (2005). Constructing measures: An item response modeling approach. 
	}
\author{
	David Torres Irribarra and Rebecca Freund.
}

\examples{

# Generating mock data
sampleLabels <- paste('item',1:10)

fitBounds <- (abs(rnorm(10, mean = 0, sd = .05)) * 2)
fitEst <- rnorm(10, mean = 1, sd = .1)

fitLB <- 1 - fitBounds
fitUB <- 1 + fitBounds
par("mar")
# running fitgraph
fitgraph(fitEst,fitLB,fitUB,itemLabels=sampleLabels)

#From ConQuest output:
	
	fpath <- system.file("extdata", package="WrightMap")

	fitgraph(file.path(fpath,"ex2.shw"))



}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ hplot }

\name{make.deltas}
\alias{make.deltas}
\alias{make.deltas.default}
\alias{make.deltas.CQmodel}
\alias{make.deltas.character}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Calculate Master's Delta parameters.
}
\description{
This function takes as its input a CQmodel object or the name of a ConQuest show file. It adds together the parameters as specified by the user, or if no tables are specified it reads the model equation to determine the appropriate tables to sum. This function is used by wrightMap to draw the item side of the map when a CQmodel is passed to wrightMap.
}
\usage{
make.deltas(item.params, ...)
\method{make.deltas}{character}(item.params, ...)
\method{make.deltas}{CQmodel}(item.params, item.table = NULL, interactions = NULL, 
step.table = NULL, item.sign = NULL, inter.sign = NULL, 
	step.sign = NULL, ...)
\method{make.deltas}{default}(item.params, cross.params = 0, step.params = 0, 
item.sign = 1, step.sign = 1, inter.sign = 1, ...)
}

\arguments{
  \item{item.params}{
The item parameters. Can either be a vector, a CQmodel object, or a path to a ConQuest show file}
\item{item.table}{If item.params is a CQmodel object or a path to a ConQuest show file, item.table is the name of the items table. Commonly "item" but can be any string representing the name of a table in the ConQuest show file. This identifies what variable will form the rows of the delta matrix. If not specified, will be the first variable mentioned in the model equation.}
\item{interactions}{If item.params is a CQmodel object or a path to a ConQuest show file, item.table is the name of the table with the interactions (if present). Commonly "item*step" but can be any string containing "*" that is the name of a table in the ConQuest show file. Should be the product of the item.table variable and the step.table variable (if present). If not specified, will be the product term of the model equation.}
\item{step.table}{If item.params is a CQmodel object or a path to a ConQuest show file, step.table is the name of the steps table (if present). Commonly "step" but can be any string representing the name of a table in the ConQuest show file. This identifies what variable will form the columns of the delta matrix. If not specified, will be the second variable mentioned in the model equation.}
\item{item.sign}{Can be 1 or -1. Indicates whether the item parameters should be added or subtracted.}
\item{inter.sign}{Can be 1 or -1. Indicates whether the interaction parameters should be added or subtracted.}
\item{step.sign}{Can be 1 or -1. Indicates whether the step parameters should be added or subtracted.}
\item{cross.params}{If item.params is a vector, use this parameter to pass a matrix of interaction parameters.}
\item{step.params}{If item.params is a vector, use this parameter to pass a matrix of step parameters.}
  \item{\dots}{Additional parameters
}
}
\details{
This function reshapes the tables in the ConQuest show file and adds the step parameters to the appropriate items. The vector version of this is rarely called by the user. 
}
\value{
A matrix in which each row is an item and each column is a step
}

\author{
Rebecca Freund & David Torres Irribarra
}


\seealso{
 \code{\link{make.thresholds}}
 \code{\link{CQmodel}}
 \code{\link{wrightMap}}
}
\examples{
fpath <- system.file("extdata", package="WrightMap")

# Partial credit model
model1 <- CQmodel(file.path(fpath,"ex2a.eap"), file.path(fpath,"ex2a.shw")) 
make.deltas(model1)

# Rating scale model
model2 <- CQmodel(file.path(fpath,"ex2b.eap"), file.path(fpath,"ex2b-2.shw")) 
make.deltas(model2)

# Raters, criteria, topics
model3 <- CQmodel(file.path(fpath,"ex4a.mle"), file.path(fpath,"ex4a.shw")) 
make.deltas(model3, item.table = "rater")
make.deltas(model3, item.table = "rater", interactions = "rater*topic", step.table = "topic")
}

\name{wrightMap}
\alias{wrightMap}
\alias{plot.CQmodel}
\title{
wrightMap: item-person maps
}
\description{
This function allows the easy generation of `Wright Maps' (named after Ben Wright), also known as item-person maps. They are used to to display unidimensional and multidimensional assessment results. These maps represent simultaneously the proficiency distribution of respondents and the item difficulty parameters as estimated by a model of the Rasch family.
}
\usage{
wrightMap(thetas, thresholds = NULL, item.side = itemModern, person.side = personHist
,  main.title = "Wright Map", min.logit.pad = 0.25, max.logit.pad = 0.25, min.l = NULL
, max.l = NULL, item.prop = 0.8, return.thresholds = TRUE, new.quartz = FALSE
, use.hist = NULL, item.groups = NULL, item.group.cex = 0.6, axis.items.cex = 0.7, ...)
\method{plot}{CQmodel}(x, \dots)
}

\arguments{

The parameters documented here do not include many of the options included in the Wright Map family of functions. For graphical parameters, see \code{\link{item.side}} and \code{\link{person.side}}. For data handling, see \code{\link{item.person.data}} and \code{\link{CQmodel}}.

wrightMap parameters:


  \item{thetas}{
    a vector, matrix or data frame of person parameter estimates. Can also be a character string specifying a ConQuest output file of person parameter estimates, or a CQmodel object. Will be sent to the function \code{\link{personData}}.
}
  \item{thresholds}{
    matrix or data frame of item parameter estimates. Can also be a character string specifying a ConQuest show file. Will be sent to the function \code{\link{itemData}}.
}
  \item{item.side}{
   function to use to draw the item side of the map. Currently included options are itemModern (default), itemClassic (for ConQuest-style Wright Maps) and itemHist. See \code{\link{item.side}} for details.
}
  \item{person.side}{
   function to use to draw the person side of the map. Currently included options are personHist (default), to draw the person distribution as a histogram, and personDens, which draws a density plot. See \code{\link{person.side}} for details.
}

  \item{main.title}{
  title of the Wright Map. Set to \code{NULL} or \code{""} to remove the title entirely and reclaim the space at the top of the plot.
}
  \item{min.logit.pad}{
  numeric value indicating how much of the lower end of the logit scale should be included in the plot.
}
  \item{max.logit.pad}{
  numeric value indicating how much of the upper end of the logit scale should be included in the plot.
}
  \item{min.l}{
  numeric value for fixing the lower end of the logit scale. It overrides the automatic detection of the range and the \code{min.logit.pad} correction.
}
  \item{max.l}{
  numeric value for fixing the upper end of the logit scale. It overrides the automatic detection of the range and the \code{max.logit.pad} correction.
}
  \item{item.prop}{
  numeric value greater than 0 and smaller than 1 indicating the proportion of the plot to be allocated to the item part of the Wright Map.
}
  \item{return.thresholds}{
  logical. Determines whether the to return or not the numeric values used to position the parameters on the item side of the Wright Map. Enabled by default.
  }
  \item{new.quartz}{
  logical. Determines whether the wrightMap will be created on a new graphical device or if it will reuse one already open. By default is set to \code{FALSE} to avoid creating new devices.
}
  \item{use.hist}{
    deprecated. Use the \code{\link{person.side}} parameter instead
}
  \item{item.groups}{
    optional vector or factor specifying group membership for each item (e.g., content strands like "Algebra", "Probability", "Calculus"). When provided, the item side of the Wright Map is split into multiple panels, one for each unique group. Each panel displays the group name as its x-axis label, with a shared "Items" label below all panels. The length of this vector must match the number of rows in \code{thresholds}. If a factor is provided, the order of levels determines the order of panels; otherwise, panels appear in the order groups first appear in the vector. Items do not need to be contiguous in the dataset; they will be correctly assigned to their respective panels based on group membership while preserving their original names. When using \code{item.groups}, the \code{cutpoints} parameter can accept either a numeric vector (applied to all panels) or a named list to specify different cutpoints for each panel (e.g., \code{cutpoints = list(Algebra = c(-1, 0), Probability = c(0, 1))}). Groups not included in the list will have no cutpoints.
}
  \item{item.group.cex}{
    numeric value specifying the font size magnification for the item group names when using \code{item.groups}. Default is 0.6.
}
  \item{axis.items.cex}{
    numeric value specifying the font size magnification for the shared "Items" label when using \code{item.groups}. Default is 0.7.
}
  \item{\dots}{
  Additional arguments to pass to \code{\link{personData}}, \code{\link{itemData}}, \code{\link{person.side}}, or \code{\link{item.side}}
}

  
 wrightMap can also be called by passing a CQmodel object to plot:
 
 \item{x}{ CQmodel object to pass to plot}



}

\references{
  Wilson, M. (2005). Constructing measures: An item response modeling approach. 
  Wright, B. D., & Stone, M. H. (1979). \emph{Best test design.} Chicago: Mesa Press. 
}

\author{David Torres Irribarra and Rebecca Freund}
\seealso{
\code{\link{person.side}}
\code{\link{item.side}}
\code{\link{personData}}
\code{\link{itemData}}
}

\examples{

# Plotting results of a unidimensional Rasch Model

## Mock results
  uni.proficiency <- rnorm(1000, mean =  -0.5, sd = 1)
  difficulties  <- sort( rnorm( 20))

## Default map
wrightMap( uni.proficiency, difficulties)

## Density version
wrightMap( uni.proficiency, difficulties, person.side = personDens)


# Plotting results of a multidimensional Rasch Model

## Mock results
  multi.proficiency <- data.frame(
    d1 = rnorm(1000, mean =  -0.5, sd = 1),
    d2 = rnorm(1000, mean =   0.0, sd = 1),
    d3 = rnorm(1000, mean =  +0.5, sd = 1))

  difficulties  <- sort( rnorm( 20))

dev.new(width=10, height=10)
wrightMap( multi.proficiency, difficulties)

# Plotting results of a unidimensional Rating Scale Model
# Thresholds without column names will use default labels: 1, 2, 3, etc.

## Mock results
  uni.proficiency <- rnorm(1000, mean =  -0.5, sd = 1)

  items.loc <- sort( rnorm( 20))
  thresholds <- cbind(
    items.loc - 0.5,
    items.loc - 0.25,
    items.loc + 0.25,
    items.loc + 0.5)
  rownames(thresholds) <- paste0("Item", 1:20)

wrightMap( uni.proficiency, thresholds)

## With transition labels (0/1, 1/2, 2/3, etc.)
wrightMap( uni.proficiency, thresholds, thr.lab.type = "transition")

# Plotting with item groups (multiple item panels by content strand)

## Mock results with content strands
  uni.proficiency <- rnorm(1000, mean = -0.5, sd = 1)

  # Create items with different strands (matrix without column names for default 1, 2, 3 labels)
  n.items <- 15
  items.loc <- sort(rnorm(n.items))
  thresholds <- cbind(
    items.loc - 0.5,
    items.loc,
    items.loc + 0.5)
  rownames(thresholds) <- paste0("Item", 1:n.items)

  # Assign items to content strands
  strands <- c(rep("Algebra", 5), rep("Probability", 5), rep("Calculus", 5))

## Wright Map with multiple item panels
wrightMap(uni.proficiency, thresholds, item.groups = strands)

## Wright Map with no title (reclaims space at top)
wrightMap(uni.proficiency, thresholds, item.groups = strands, main.title = NULL)

## Wright Map with adjusted font sizes for group labels
wrightMap(uni.proficiency, thresholds, item.groups = strands,
          item.group.cex = 0.8, axis.items.cex = 0.9)

## Wright Map with different cutpoints per panel
wrightMap(uni.proficiency, thresholds, item.groups = strands,
          cutpoints = list(
            Algebra = c(-1, 0),
            Probability = c(0, 1),
            Calculus = c(-0.5, 0.5)
          ))


    ####ConQuest integration###
  
  	fpath <- system.file("extdata", package="WrightMap")
  	
  	#Partial credit model:

	model1 <- CQmodel(p.est = file.path(fpath,"ex2.eap"), show = file.path(fpath,"ex2.shw"))
	wrightMap(model1) 
	
	# Rating scale model:
	model2 <- CQmodel(file.path(fpath,"ex2b.eap"), file.path(fpath,"ex2b-2.shw"))
	wrightMap(model2, label.items.row = 2) 
		
  # Complex model
	model3 <- CQmodel(file.path(fpath,"ex4a.mle"), file.path(fpath,"ex4a.shw")) 
	wrightMap(model3, min.logit.pad = -29, person.side = personDens)
	
	
  ### Skip CQmodel
	wrightMap(file.path(fpath,"ex2a.eap"), file.path(fpath,"ex2a.shw"), 
  label.items.row = 3) 

}

\name{WrightMap}
\alias{WrightMap-package}
\alias{WrightMap}
\docType{package}
\title{
Wright Map: IRT Item-Person Map
}
\description{
This package allows the easy generation of `Wright Maps' (named after Ben Wright), also known as item-person maps to display unidimensional and multidimensional assessment results. These maps represent simultaneously the proficiency distribution of respondents and the item difficulty parameters as estimated by a model of the Rasch Family. The package contains several other functions for graphing common IRT statistics.

Additionally, the package contains the \code{CQmodel} function, which reads output files created using ConQuest software and creates a set of data frames for easy data manipulation, bundled in a CQmodel object. The wrightMap function can take a CQmodel object as input or it can be used to create Wright Maps directly from data frames of person and item parameters.
}
\details{
\tabular{ll}{
Package: \tab WrightMap\cr
Type: \tab Package\cr
Version: \tab 1.5\cr
Date: \tab 2026-08-23\cr
License: \tab BSD_2_clause + file LICENSE \cr
}
The wrightMap function relies on two main inputs: (a) \code{thetas}: a vector or matrix of respondent proficiencies, and (b) \code{thresholds}: a vector or matrix of item thresholds. In the simplest case, say for a unidimensional Rasch model, \code{thetas} can be a vector of person proficiencies and \code{thresholds} a vector of item difficulties. 

To plot multiple dimensions of person proficiency, simply provide them as a matrix were the results for each dimension is stored in a different column, such that for a 3-dimensional model with 1,000 persons, \code{theta} is a matrix of 1000 rows and 3 columns. 

To plot polytomous items, the thresholds for each level must be passed to the functions through the \code{thresholds} matrix, where each row represents an item and each column represents a level. For instance, if the results of a Rating Scale model with 5 response categories and 10 items is being plotted, the \code{thresholds} matrix will have 10 rows and 4 columns ( column one represents the thresholds between the 1 and 2 response category, column 2 the threshold between categories 2 and 3, etc.).

Alternatively, wrightMap can read directly the \code{.shw} and \code{.eap/.mle/.wle} output files from a Conquest analysis, and will automatically generate the \code{thetas} and \code{thresholds} matrices.

}
\author{
David Torres Irribarra and Rebecca Freund

Maintainer: David Torres Irribarra <david@torresirribarra.me>
}
\references{
	Andrich, D. (1978). A rating formulation for ordered response categories. \emph{Psychometrika}, \emph{43}(4), 561--573. 
	Masters, G. N. (1982). A Rasch model for partial credit scoring. \emph{Psychometrika}, \emph{47}(2), 149--174. 
	Wilson, M. (2005). Constructing measures: An item response modeling approach. 
	Wright, B. D., & Stone, M. H. (1979). \emph{Best test design.} Chicago: Mesa Press. 
}

\keyword{Wright Map}
\keyword{IRT}
\keyword{Item Response Models}
\keyword{Rasch Model}


\examples{

# Plotting results of a unidimensional Rasch Model

## Mock results
	uni.proficiency <- rnorm(1000, mean =  -0.5, sd = 1)
	difficulties  <- sort( rnorm( 20))

## Default map
wrightMap( uni.proficiency, difficulties)

## Density version
wrightMap( uni.proficiency, difficulties, person.side = personDens)

# Plotting results of a multidimensional Rasch Model

## Mock results
	multi.proficiency <- data.frame(
		d1 = rnorm(1000, mean =  -0.5, sd = 1),
		d2 = rnorm(1000, mean =   0.0, sd = 1),
		d3 = rnorm(1000, mean =  +0.5, sd = 1))

	difficulties  <- sort( rnorm( 20))

dev.new(width=10, height=10)
wrightMap( multi.proficiency, difficulties)

# Plotting results of a unidimensional Rating Scale Model

## Mock results
	uni.proficiency <- rnorm(1000, mean =  -0.5, sd = 1)

	items.loc <- sort( rnorm( 20))
	thresholds <- data.frame(
		l1 = items.loc - 0.5,
		l2 = items.loc - 0.25,
		l3 = items.loc + 0.25,
		l4 = items.loc + 0.5)

dev.new(width=10, height=10)
wrightMap( uni.proficiency, thresholds)

## Setting up labels, colors and symbols

	thresholds.labels <- data.frame(
		l1 = paste('Lev',rep(1,20),sep = ''),
		l2 = paste('Lev',rep(2,20),sep = ''),
		l3 = paste('Lev',rep(3,20),sep = ''),
		l4 = paste('Lev',rep(4,20),sep = ''))

	thresholds.colors <- data.frame(
		l1 = rep(  'green',20),
		l2 = rep(    'red',20),
		l3 = rep( 'yellow',20),
		l4 = rep(   'blue',20))

	thresholds.symbols <- data.frame(
		l1 = rep( 15,20),
		l2 = rep( 16,20),
		l3 = rep( 17,20),
		l4 = rep( 18,20))

dev.new(width=10, height=10)
wrightMap( uni.proficiency, thresholds
	, thr.lab.text = thresholds.labels
	, thr.lab.col = as.vector(as.matrix(thresholds.colors))
	, thr.sym.pch = thresholds.symbols
	)

}

\name{plotCI}
\alias{difplot}
\alias{difplot.default}
\alias{difplot.CQmodel}
\alias{difplot.character}
\alias{plotCI}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Plotting confidence intervals and DIF
}
\description{The \code{plotCI} function is intended for graphing confidence intervals. The \code{difplot} function is a wrapper for \code{plotCI} specifically intended for examining Differential Item Functioning from ConQuest output.
}
\usage{
plotCI(ests, errors, labels = "", zeroline = TRUE, incol = "gray", outcol = "blue"
, main.title = "Statistical Significance Plot", axes = FALSE, xlab = "", pch = 16, \dots)
\method{difplot}{default}(data, grouptype = NULL, group = NULL, item.names = NULL
, ylim = c(-1, 1), ylab = NULL, \dots)
\method{difplot}{CQmodel}(data, table.name = NULL, grouptype = NULL
, group = NULL, \dots)
\method{difplot}{character}(data, equation, \dots)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
	
	\code{plotCI} parameters:
	
	\item{ests}{vector of point estimates.}
	\item{errors}{vector of standard errors.}
	\item{labels}{vector of labels for the items.}
	\item{zeroline}{logical indicating whether to draw a line at zero.}
	\item{incol}{color of intervals containing zero.}
	\item{outcol}{color of intervals not containing zero.}
	\item{main.title}{title of the plot.}
	\item{axes,xlab,pch}{parameters passed to \code{\link{plot}}.}

	\code{difplot} parameters:
	
  \item{data}{A \code{CQmodel} object or the name of a ConQuest show file. Can also be a table of parameters taken from ConQuest output.}
  \item{table.name}{The RMP table to use for parameters. Should be an interactions table.}
  \item{grouptype}{The name of the demographic variable (e.g. ``gender'').}
  \item{group}{The name of the group to test for DIF (e.g. ``male'').}
  \item{item.names}{vector of item names.}
  \item{equation}{string specifying the model equation, if the Summary of Estimation table was not included in the show file. }
  
  \item{ylim,ylab}{more parameters passed to \code{\link{plot}}.}
  
  \item{\dots}{additional parameters to pass to \code{plot}.
}
}
\details{
The \code{plotCI} function takes point estimates and standard errors as inputs and plots 95 percent confidence intervals in relation to a zero-line. By default, it colors the intervals gray if they include zero, and blue if they do not. The \code{difplot} function is a wrapper for \code{plotCI} specifically intended for examining Differential Item Functioning from ConQuest output and expects tables formatted exactly like ConQuest output to work correctly. For plotting DIF from other statistical packages, it is recommended to use \code{plotCI} directly.
}

\author{David Torres Irribarra and Rebecca Freund}

\examples{
	#Plotting confidence intervals
	
	ests <- rnorm(10,sd = .5)
	errors <- runif(10,min = .1,max = .5)
	plotCI(ests,errors,ylim = c(-3,3))
	
	#DIF plot:
	
	fpath <- system.file("extdata", package="WrightMap")

	# equation must be specified because there is no summary of estimation 
	# table in this example
	difplot(file.path(fpath,"ex6a.shw"), equation = "item-gender+item*gender") 

}

\name{CQmodel}
\alias{CQmodel}
\alias{print.CQmodel}
\alias{print.SOE}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ConQuest Output Processing}
\description{The CQmodel function reads ConQuest item parameter and person parameter output files and converts them into a list of data frames for more convenient data processing.}
\usage{
CQmodel(p.est = NULL, show = NULL, p.type = NULL, equation = NULL)
\method{print}{CQmodel}(x,\dots)
\method{print}{SOE}(x,\dots)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{p.est}{ Conquest person parameters file (EAPs, MLEs, etc.). }
  \item{show}{ ConQuest show file. }
  \item{p.type}{ Type of person parameter estimate (EAP, MLE or WLE). If not specified, will try to determine from the extension of the p.est file. }
  \item{equation}{ String giving the model equation, if the Summary of Estimation table was not included in the show file.}
  \item{x}{ Object that determines which function to call. }
  \item{...}{Additional arguments.}
}

\value{
CQmodel returns an object of type CQmodel. Usually contains:
Tables:
\item{RMP}{ A list of data frames containing the response model parameter estimates. One data frame is created for each table in the output. Each data frame contains parameter estimates, errors, and fit information.}
\item{GIN}{ A matrix containing the item thresholds (if included in the ConQuest output). The rows are items and the columns are steps.}
\item{p.est}{ A data frame containing the person parameter estimates }


Summary of estimation:
\item{SOE}{A list of various parameters related to the estimation}
Items that may be in the SOE list include:
\item{method}{ Estimation method }
\item{distribution}{ Assumed population distribution }
\item{constraint}{ Constraint}
\item{format}{ Specified format of the datafile }
\item{equation}{ A character string containing the item model (e.g. "item+item*step") }
\item{participants}{ Sample size }
\item{deviance}{ Final deviance of the model }
\item{parameters}{ Total number of estimated parameters }
\item{iterations}{ Number of iterations }
\item{seed}{ Random number generation seed }
\item{PV.nodes}{ Number of nodes used when drawing PVs }
\item{fit.nodes}{ Number of nodes used when computing fit }
\item{n.plausible.values}{ Number of plausible values drawn }
\item{max.iterations.no.improvement}{ Maximum number of iterations without a deviance improvement }
\item{max.steps}{ Maximum number of Newton steps in M-step }
\item{zero.perfect.value}{ Value for obtaining finite MLEs for zero/perfects }
\item{termination.reason}{ Reason for iteration termination }
\item{max.iterations}{}
\item{parameter.change}{}
\item{deviance.change}{}

Run details:
\item{run.details}{ A list of details of the run }
Items that may be included in the run.details list include:
\item{date}{ The date of the ConQuest run }
\item{data.file}{ The name of the datafile used }
\item{format}{ The specified format of the datafile }
\item{names}{ Names of items and/or dimensions }




Additional items:
\item{deviance}{ The deviance of the model }
\item{equation}{ A character string containing the model specification (e.g. "item+item*step") }
\item{participants}{ The number of participants }
\item{parameters}{ The number of parameters }
\item{title}{ The run title }
\item{reg.coef}{ Regression coefficients }
\item{rel.coef}{ Reliability coefficients }
\item{variances}{}
\item{nDim}{ Number of dimensions }
\item{dimensions}{ Dimension names }
\item{p.est.type}{}
}

\author{Rebecca Freund and David Torres Irribarra}


\examples{
	
fpath <- system.file("extdata", package="WrightMap")

# Partial credit model
model1 <- CQmodel(p.est = file.path(fpath,"ex2.eap"), 
show = file.path(fpath,"ex2.shw")) 
model1 #Shows what tables are available

model1$SOE #Summary of estimation
model1$equation # Model specification
model1$reg.coef # Regression coefficients
model1$rel.coef # Reliability coefficients
model1$variances # Variances

names(model1$RMP) # Names of parameter tables
head(model1$RMP$item) #Item parameters
head(model1$RMP$"item*step") #Item by step parameters

# Complex model
model2 <- CQmodel(file.path(fpath,"ex4a.mle"), 
file.path(fpath,"ex4a.shw")) 
model2$equation # Model specification
names(model2$RMP) # Names of parameter tables
head(model2$RMP$"rater*topic*criteria*step") #An interaction table

model1$GIN #Item thresholds
model2$GIN #Item thresholds

head(model1$p.est)  ##EAPs
head(model2$p.est)  ##MLEs

}

\name{ppPlot}
\alias{ppPlot}
\alias{cutLines}
\alias{kidmap}

\title{Person probability plots
}
\description{
Plots a Wright Map for a single person (similar to a kidmap). On the person side, highlights their estimated ability and a range of one standard error. On the item side, draws lines representing item difficulties at which they are expected to have a 20\%, 40\%, 50\%, 60\%, and 80\% chance of success.}
\usage{
ppPlot(thetas, thresholds, est, SE, main.title = "Person Probability Plot"
, cut.left = 0, cut.right = .94, cut.lab.adj = c(1,.5),\dots)

cutLines(cutpoints = NULL,cut.left = 0, cut.right = 1, cut.lab.text = NULL
, cut.lab.adj = c(0,1),\dots)
}
\arguments{
  \item{thetas}{
    a vector, matrix or data frame of person parameter estimates. Can also be a character string specifying a ConQuest output file of person parameter estimates, or a CQmodel object. Will be sent to the function \code{\link{personData}}.
}
  \item{thresholds}{
    matrix or data frame of item parameter estimates. Can also be a character string specifying a ConQuest show file. Will be sent to the function \code{\link{itemData}}.
 }
 \item{est}{
 	estimated ability of the person
 }
 \item{SE}{
 	standard error of the estimate
 }
 \item{main.title}{
  title of the Person Probability Plot.
}
\item{cut.left}{
	value between 0 and 1 describing where to place the lefthand side of the cutpoints, as a fraction of the item plot.
 }
 \item{cut.right}{
	value between 0 and 1 describing where to place the righthand side of the cutpoints, as a fraction of the item plot.
 }
 \item{cut.lab.adj}{
 	similar to the \code{adj} parameter in \code{\link{text}}, describes where to place the text for the cutpoints as a pair of values between 0 and 1 in terms of left-right and up-down alignment. Left-right alignment is 0 for the left side of the item plot and 1 for the right side, while up-down alignment is 0 for below the line and 1 for above the line.
 }
 \item{cutpoints}{
 	argument to \code{cutLines} when called through \code{wrightMap} or one of the \code{\link{item.side}} functions. Specifies locations of cutlines. When \code{cutLines} is called through \code{ppPlot}, the cutpoints are calculated rather than specified. 
 }
 \item{cut.lab.text}{
 	argument to \code{cutLines} when called through \code{wrightMap} or one of the \code{\link{item.side}} functions. Specifies text to appear for each cut line. When \code{cutLines} is called through \code{ppPlot}, the text is always the percent chance of success given the estimated ability level and difficulty location. 	
 }
 
 \item{\dots}{
 	additional arguments to pass to \code{\link{wrightMap}} or its associated functions.
 }
}
\details{
	The \code{ppPlot} function is a wrapper for \code{\link{wrightMap}} that is specifically designed for person probability plots, and as such has access to all the parameters of wrightMap and its associated functions. It uses the \code{person.points}, \code{person.range}, \code{p.point.col}, and \code{p.range.col} parameters on the \code{\link{person.side}} function to draw a range of one standard error around the estimated ability level. On the item side, it calculates at what item difficulty the respondent is expected to have a 20\%, 40\%, 50\%, 60\%, and 80\% chance of success and then uses the \code{cutLines} function to illustrate these cutpoints. The cutLines function should not be called on its own and may be hidden in future versions. It is included here to show the available parameters, which can be included in a call to \code{wrightMap} or any of the \code{item.side} functions.
	}


\author{
David Torres Irribarra and Rebecca Freund}

\seealso{
 \code{\link{wrightMap}}
}
\examples{
	
	fpath <- system.file("extdata", package="WrightMap")
	model1 <- CQmodel(p.est = file.path(fpath,"ex2.eap"), show = file.path(fpath,"ex2.shw"))
	
	#Person histogram, modern item
	ppPlot(model1,est = 0, SE = 1) 
	
	#Person density, classic item
	ppPlot(model1,est = 0, SE = 1, person.side = personDens,item.side = itemClassic) 
	
}
